#ifndef __npl_synch_h__
#define __npl_synch_h__
/*============================================================================
=  Novell Portability Layer Implementation
=
=  Unpublished Copyright (C) 1997 by Novell, Inc. All rights reserved.
=
=  No part of this file may be duplicated, revised, translated, localized or
=  modified in any manner or compiled, linked or uploaded or downloaded to or
=  from any computer system without the prior written consent of Novell, Inc.
=
=  npl/synch.h
==============================================================================
*/

#include <npl/types.h>

#if 0
/* compilation options for synchronization primitives: */
#define DEBUG
#define _LOCKTEST
#define _LOCKSTAT
#endif


/* Synchronization Services */
NXCond_t		*NXCondAlloc(void *arg);
void			NXCondBroadcast(NXCond_t *cond);
void			NXCondDeAlloc(NXCond_t *cond);
void			NXCondDeInit(NXCond_t *cond);
int			NXCondInit(NXCond_t *cond, void *arg);
void			NXCondSignal(NXCond_t *cond);
int			NXCondTimedWait(NXCond_t *cond, NXMutex_t *mutex, 
					unsigned long interval);
int			NXCondWait(NXCond_t *cond, NXMutex_t *mutex);
NXMutex_t	*NXAllocMutex(NXHierarchy_t hierarchy, NXLockInfo_t *info);
void			NXDeAllocMutex(NXMutex_t *mutex);
void			NXDeInitMutex(NXMutex_t *mutex);
int			NXInitMutex(NXMutex_t *mutex, NXHierarchy_t hierarchy, 
					NXLockInfo_t *info);
void			NXLock(NXMutex_t *mutex);
NXBoolean_t	NXMutexOwned(NXMutex_t *mutex);
NXBoolean_t	NXTryLock(NXMutex_t *mutex);
void			NXUnlock(NXMutex_t *mutex);
NXRWMutex_t	*NXAllocRWMutex(NXHierarchy_t hierarchy, NXLockInfo_t *info);
void			NXDeAllocRWMutex(NXRWMutex_t *mutex);
void			NXDeInitRWMutex(NXRWMutex_t *mutex);
int			NXInitRWMutex(NXRWMutex_t *mutex, NXHierarchy_t hierarchy,
					NXLockInfo_t *info);
NXBoolean_t	NXRWMutexOwned(NXMutex_t *mutex, unsigned long mode);
void			NXRdLock(NXRWMutex_t *mutex);
NXBoolean_t	NXTryRdLock(NXRWMutex_t *mutex);
NXBoolean_t	NXTryWrLock(NXRWMutex_t *mutex);
void			NXRWUnlock(NXRWMutex_t *mutex);
void			NXWrLock(NXRWMutex_t *mutex);
NXSema_t		*NXSemaAlloc(unsigned int count, void *arg);
void			NXSemaDeAlloc(NXSema_t *sema);
void			NXSemaDeInit(NXSema_t *sema);
int			NXSemaInit(NXSema_t *sema, unsigned int count, void *arg);
void			NXSemaPost(NXSema_t *sema);
NXBoolean_t	NXSemaTryWait(NXSema_t *sema);
void			NXSemaWait(NXSema_t *sema);

#endif
