#ifndef __npl_thread_h__
#define __npl_thread_h__
/*============================================================================
=  Novell Portability Layer Implementation
=
=  Unpublished Copyright (C) 1997 by Novell, Inc. All rights reserved.
=
=  No part of this file may be duplicated, revised, translated, localized or
=  modified in any manner or compiled, linked or uploaded or downloaded to or
=  from any computer system without the prior written consent of Novell, Inc.
=
=  npl/thread.h
==============================================================================
*/
#include <npl/defs.h>
#include <npl/types.h>

/* Context Management Services */
NXContext_t		*NXAllocContext(void (*start_routine)(void *arg),
						int priority, void *arg, NXSize_t private, NXSize_t stack,
						long flags, int *error);
int				NXDestroyContext(NXContext_t *ctx);
int				NXGetNameContext(NXContext_t *ctx, char **name);
int				NXSetNameContext(NXContext_t *ctx, const char *name);
NXContext_t		*NXThreadGetContext(void);
int				NXThreadSetContext(NXContext_t *ctx);
 
/* Thread Management Services */
int				NXDeleteWork(NXWorkId_t work_id);
NXBoolean_t		NXProcessInterruptSet(NXInterruptSet_t *set, NXInterruptId_t id,
						NXInterruptId_t *processed_id);
int				NXScheduleWork(NXContext_t *ctx, NXWorkId_t *work_id);
int				NXScheduleDelayedWork(NXContext_t *ctx, NXTimerVal_t *timerval,
						NXWorkId_t *id);
int				NXThreadBind(unsigned int cpu_id);
int				NXThreadContinue(NXThreadId_t id);
int				NXThreadCreate(NXContext_t *ctx, long flags, NXThreadId_t *idp);
void				NXThreadDelay(unsigned long delay);
void				NXThreadExit(void *status);
unsigned int	NXThreadGetBinding(void);
NXThreadId_t	NXThreadGetId(void);
void				*NXThreadGetPrivate(void);
int				NXThreadInterrupt(NXThreadId_t id, NXInterruptId_t interrupt);
NXBoolean_t		NXThreadInterrupted(NXInterruptSet_t *set);
int				NXThreadJoin(NXThreadId_t wait_for,
						NXThreadId_t *departed_thread, void **status);
int				NXThreadSuspend(NXThreadId_t id);
void				NXThreadYield(void);

/* Scheduler Control Services */
int				NXThreadGetPriority(NXThreadId_t id, int *priority);
int				NXThreadSetPriority(NXThreadId_t id, int priority);

#endif
