/*
//ͻ
// (c) 1995-1998 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_DOC.H                                           
//͹
// Library VeRsIoN=1.1.0                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_DOC_H )
   #define NWDP_DOC_H

/* Standard Library Header Includes */

/* Header Includes */
   #if !defined(NWDP_LIB_H)
      #include <nwdp_lib.h>
   #endif
   #if !defined(NWDP_ATR_H)
      #include <nwdp_atr.h>
   #endif



/* Manifest Constant Definitions */
   #define NWDP_DOC_POSITION_LAST  ((nuint)-1)

/* Macro Definitions */

/* Type Definitions */

/* Callback Definitions */

 N_TYPEDEF_CALLBACK(nint,
NWDPDocTransferFileCallback)(
   NWDPAccessorRef accessorRef,
   nparam          callerDefinedParam,
   nuint32         totalBytesToBeTransferred,
   nuint32         currentNumberTransferred
   );

/* Global Variable Declarations */

/* Function Prototype Declarations */

 N_EXTERN_LIBRARY(nint)
NWDPDocCancel(
   NWDPAccessorRef accessorRef,
   NWDPDocRef docRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPDocCreateRef(
   NWDPAccessorRef accessorRef,
   NWDPJobRef jobRef,
   nuint position,
   NWDPAttrSetRef attrSetRef,
   pNWDPDocRef docRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPDocCreateRefBasedOnDocId(
   NWDPAccessorRef accessorRef,
   NWDPJobRef jobRef,
   nuint32 docId,
   pNWDPDocRef docRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPDocDestroyRef(
   NWDPAccessorRef accessorRef,
   pNWDPDocRef docRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPDocGetAttributeSet(
   NWDPAccessorRef   accessorRef,
   NWDPDocRef        docRef,
   NWDPOidSetRef     requestedOidSetRef,
   pNWDPAttrSetRef   resultAttrSetRefPtr,
   pNWDPASAVPRef     avpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPDocGetId(
   NWDPAccessorRef accessorRef,
   NWDPDocRef docRef,
   pnuint32 docIdPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPDocModifyAttrs(
   NWDPAccessorRef accessorRef,
   NWDPDocRef docRef,
   NWDPAttrSetRef modifyRef,
   NWDPModifyOperatorEnum docOperator
   );

 N_EXTERN_LIBRARY(nint)
NWDPDocTransferFile(
   NWDPAccessorRef accessorRef,
   NWDPDocRef docRef,
   pnstr16 sourceFilePath16Ptr,
   NWDPDocTransferFileCallback progressFunc,
   nparam callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPDocValidateRef(
   NWDPAccessorRef accessorRef,
	NWDPDocRef docRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPDocWriteBuf(
   NWDPAccessorRef accessorRef,
   NWDPDocRef docRef,
   nptr bufferPtr,
   nuint sizeOfBuffer
   );

#else /* NWDP_DOC_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_doc.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_DOC_H */

