/*
//ͻ
// (c) 1995-1998 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_ERR.H                                           
//͹
// Library VeRsIoN=1.1.0                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_ERR_H )
   #define NWDP_ERR_H

/* Standard Library Header Includes */
   #if !defined( NTYPES_H )
      #define N_INC_NO_OLD_CONSTANTS
      #include <ntypes.h>
      #undef  N_INC_NO_OLD_CONSTANTS
   #endif
   /* Try to guarantee that "strcpy" is known */
   #include<string.h>

/* Header Includes */

/* Manifest Constant Definitions */
   
   /*
   // Values returned for all functions other than NWDPLibInit
   // (besides N_SUCCESS and N_FAILURE)
   */
   #define  NWDP_RC_WARNING               ( 1)
   #define  NWDP_RC_INVALID_ACCESSOR      (-2)

   /*
   // Values of the libError (LE) field when N_FAILURE or
   // NWDP_RC_WARNING is returned as a function result
   */

   #define  NWDP_LE_FLT_BAD_DELIMITER_SEQ    0x00010001L /* 65537    */
   #define  NWDP_LE_FLT_BAD_MATCH_SEQ        0x00010002L /* 65538    */
   #define  NWDP_LE_FLT_UNPAIRED_RPAREN      0x00010003L /* 65539    */
   #define  NWDP_LE_FLT_MALFORMD_EXPRESSION  0x00010004L /* 65540    */
   #define  NWDP_LE_FLT_ALREADY_ENDED        0x00010005L /* 65541    */
   #define  NWDP_LE_FLT_NO_VALUES_IN_ATTR    0x00010006L /* 65542    */
   #define  NWDP_LE_FLT_SPECIFIC_VAL_REQRD   0x00010007L /* 65543    */

   #define  NWDP_LE_NO_NDPS_PRINT_PROVIDER   0x00020001L /* 131073   */

   #define  NWDP_LE_PSM_CONNECTION_LOST      0x00030001L /* 196609   */

   #define  NWDP_LE_FILE_NO_ACCESS_RIGHTS    0x00040001L /* 262145   */
   #define  NWDP_LE_FILE_NOT_FOUND           0x00040002L /* 262146   */

   #define  NWDP_LE_SRS_CONNECTION_LOST      0x00050001L /* 327681   */
   #define  NWDP_LE_SRS_NO_SRVC_REG_FOUND    0x00050002L /* 327682   */
   #define  NWDP_LE_SRS_NOT_ENABLED          0x00050003L /* 327683   */
   #define  NWDP_LE_SRS_ADDRESS_NOT_BAD      0x00050004L /* 327684   */
   #define  NWDP_LE_SRS_NEW_ADDRESS_USED     0x00050005L /* 327685   */

   #define  NWDP_LE_BRK_CONNECTION_LOST      0x00060001L /* 393217   */

   #define  NWDP_LE_DOC_INVALID_OPERATION    0x00080001L /* 524289   */
   #define  NWDP_LE_DOC_ZERO_LENGTH          0x00080002L /* 524290   */
   #define  NWDP_LE_DOC_UNVALIDATED_DOC_ID   0x00080003L /* 524291   */
   #define  NWDP_LE_DOC_NO_SUCH_DOC          0x00080004L /* 524292   */

   #define  NWDP_LE_JOB_INVALID_OPERATION    0x00090001L /* 589825   */
   #define  NWDP_LE_JOB_BAD_DOC_POSITION     0x00090002L /* 589826   */
   #define  NWDP_LE_JOB_DOC_OPEN             0x00090003L /* 589827   */
   #define  NWDP_LE_JOB_UNVALIDATED_JOB_ID   0x00090004L /* 589828   */
   #define  NWDP_LE_JOB_NO_SUCH_JOB          0x00090005L /* 589829   */

   #define  NWDP_LE_PLATFORM_NOT_SUPPORTED   0x000A0001L /* 655361   */
   #define  NWDP_LE_MEMORY_NOT_MALLOCED      0x000A0002L /* 655362   */
   #define  NWDP_LE_CANCEL_LIST              0x000A0003L /* 655363   */
   #define  NWDP_LE_CASELESS_CMP_FAILED      0x000A0004L /* 655364   */
   #define  NWDP_LE_UNKNOWN_CALLBACK_ERR     0x000A0005L /* 655365   */
   #define  NWDP_LE_RESULT_BUFFER_TOO_SMALL  0x000A0006L /* 655366   */
   #define  NWDP_LE_INVALID_INTERNAL_OP      0x000A0007L /* 655367   */
   #define  NWDP_LE_REF_NOT_CREATED_WITH_FQN 0x000A0008L /* 655368   */
   #define  NWDP_LE_FQN_NOT_NDPS_MANAGER     0x000A0009L /* 655369   */
   #define  NWDP_LE_FQN_NOT_NDPS_PRINTER     0x000A000AL /* 655370   */
   #define  NWDP_LE_FQN_NOT_NDPS_BROKER      0x000A000BL /* 655371   */

   #define  NWDP_LE_NSRV_NO_CONTEXT_IN_USE   0x000B0001L /* 720897   */
   #define  NWDP_LE_NSRV_OBJECT_EXISTS       0x000B0002L /* 720898   */
   #define  NWDP_LE_NSRV_NO_SUCH_OBJECT      0x000B0003L /* 720899   */
   #define  NWDP_LE_NSRV_WRONG_OBJECT_TYPE   0x000B0004L /* 720900   */
   #define  NWDP_LE_NSRV_NO_ADDRESS          0x000B0005L /* 720901   */
   #define  NWDP_LE_NSRV_VAL_SIZE_TOO_LARGE  0x000B0006L /* 720902   */
   #define  NWDP_LE_NSRV_NOT_SAME_TREE       0x000B0007L /* 720903   */
   #define  NWDP_LE_NSRV_INTERNAL            0x000B0008L /* 720904   */
   #define  NWDP_LE_NSRV_CONTEXT_XLATE_SET   0x000B0009L /* 720905   */
   #define  NWDP_LE_NSRV_SCHEMA_UP_TO_DATE   0x000B000AL /* 720906   */
   #define  NWDP_LE_NSRV_INVALID_RES_PATH    0x000B000BL /* 720907   */

   #define  NWDP_LE_PRT_NO_SUCH_LABEL        0x000C0001L /* 786433   */
   #define  NWDP_LE_PRT_NO_DEFAULT           0x000C0002L /* 786434   */
   #define  NWDP_LE_PRT_REC_OUT_OF_RANGE     0x000C0003L /* 786435   */
   #define  NWDP_LE_PRT_DUPLICATE_LABEL      0x000C0004L /* 786436   */
   #define  NWDP_LE_PRT_CLIENT_BLD_FAILED    0x000C0005L /* 786437   */
   #define  NWDP_LE_PRT_CLIENT_BIND_FAILED   0x000C0006L /* 786438   */
   #define  NWDP_LE_PRT_JOB_CFG_EXISTS       0x000C0007L /* 786439   */
   #define  NWDP_LE_PRT_INVALID_JOB_CFG_FMT  0x000C0008L /* 786440   */
   #define  NWDP_LE_PRT_INTERNAL_ERROR       0x000C0009L /* 786441   */
   #define  NWDP_LE_PRT_JOB_CFG_NOT_FOUND    0x000C000AL /* 786442   */
   #define  NWDP_LE_PRT_NO_SUCH_PORT         0x000C000BL /* 786443   */
   #define  NWDP_LE_PRT_DEST_TREE_DIFFERS    0x000C000CL /* 786444   */
   #define  NWDP_LE_PRT_NO_ENVIRONMENT_PATH  0x000C000DL /* 786445   */
   #define  NWDP_LE_PRT_ADDR_NO_LONGR_VALID  0x000C000EL /* 786446   */
   #define  NWDP_LE_PRT_BAD_CFG_FILE_VER     0x000C000FL /* 786447   */
   #define  NWDP_LE_PRT_PO_ALREADY_ASSIGNED  0x000C0010L /* 786448   */
   #define  NWDP_LE_PRT_PO_NOT_ASSIGNED      0x000C0011L /* 786449   */
   #define  NWDP_LE_PRT_PA_NOT_FOUND         0x000C0012L /* 786450   */
   #define  NWDP_LE_PRT_SHORTLIST_NOT_FOUND  0x000C0013L /* 786451   */
   #define  NWDP_LE_PRT_WARNING_WIN_INI_CHG  0x000C0014L /* 786452   */
   #define  NWDP_LE_PRT_INSTALLR_NOT_A_USER  0x000C0015L /* 786453   */
   #define  NWDP_LE_PRT_NO_REGISTRY_SUPPORT  0x000C0016L /* 786454   */
   #define  NWDP_LE_PRT_PORT_LIMIT_REACHED   0x000C0017L /* 786455   */
   #define  NWDP_LE_PRT_NO_SUCH_REG_NAME     0x000C0018L /* 786456   */
   #define  NWDP_LE_PRT_ALREAY_INSTALLED     0x000C0019L /* 786457   */


   /* Printer Driver Download errors */
   #define  NWDP_LE_PRT_DRV_NONE_FOR_PLAT    0x00130001L /* 1245185  */
   #define  NWDP_LE_PRT_SPCD_BROKER_NOT_FND  0x00130002L /* 1245186  */
   #define  NWDP_LE_PRT_UNSUPTED_QNAME_FMT   0x00130003L /* 1245187  */
   #define  NWDP_LE_PRT_NO_DEST_PATH         0x00130004L /* 1245188  */
   #define  NWDP_LE_PRT_DEVICE_ID_FMT_BAD    0x00130005L /* 1245189  */
   #define  NWDP_LE_PRT_NO_TMP_DEST_PATH     0x00130006L /* 1245190  */
   #define  NWDP_LE_PRT_WINDOWS_RESTART_RQD  0x00130007L /* 1245191  */

   /* Printer Driver Download error otherErrorStrPtr is file path */
   #define  NWDP_EC_PRT_NEEDED_FILE_MISSING  0x05130008L /* 85131270 */

   #define  NWDP_LE_PRT_DRV_NOT_INSTALLED    0x00130009L /* 1245193  */
   #define  NWDP_LE_PRT_PA_IS_SHUTDOWN       0x0013000AL /* 1245194  */
   #define  NWDP_LE_PRT_NDPSM_IS_NOT_LOADED  0x0013000BL /* 1245195  */
	
                        
   #define  NWDP_LE_OID_INVALID_ASCII        0x000D0001L /* 851969   */
   #define  NWDP_LE_OID_NOT_IN_DATABASE      0x000D0002L /* 851970   */
   #define  NWDP_LE_OID_UNSUPPORTED_FORMAT   0x000D0003L /* 851971   */
   #define  NWDP_LE_OID_STRING_NOT_FOUND     0x000D0004L /* 851972   */
   #define  NWDP_LE_OID_NO_STRING_THAT_KIND  0x000D0005L /* 851973   */
   #define  NWDP_LE_OID_MSG_FILE_NOT_FOUND   0x000D0006L /* 851974   */
   #define  NWDP_LE_OID_MSTR_IDX_NOT_FOUND   0x000D0007L /* 851975   */
   #define  NWDP_LE_OID_MONOCASE_NOT_FOUND   0x000D0008L /* 851976   */
   #define  NWDP_LE_OID_ENUM_XLAT_NOT_FOUND  0x000D0009L /* 851977   */
   #define  NWDP_LE_OID_NOT_LANG_CONTEXT     0x000D000AL /* 851978   */
   #define  NWDP_LE_OID_ALREADY_IN_SET       0x000D000BL /* 851979   */
   #define  NWDP_LE_OID_NOT_IN_SET           0x000D000CL /* 851980   */
   #define  NWDP_LE_OID_NOT_FOUND            0x000D000DL /* 851981   */
   #define  NWDP_LE_OID_INVALID_ASN1_TYPE    0x000D000EL /* 851982   */
   #define  NWDP_LE_OID_IS_OBJECT_CLASS      0x000D000FL /* 851983   */
   #define  NWDP_LE_OID_IS_VALUE_CLASS       0x0000L /* 851984   */
   #define  NWDP_LE_OID_IS_VALUE             0x0001L /* 851985   */
   #define  NWDP_LE_OID_NO_LANGUAGE_PATH     0x0002L /* 851986   */


   #define  NWDP_LE_TIRPC_TRANSPORT_UNSUP    0x000E0001L /* 917505   */
   #define  NWDP_LE_TIRPC_TRANSPORT_UNKWN    0x000E0002L /* 917506   */

   #define  NWDP_LE_MODB_NO_SUCH_OBJECT      0x000F0001L /* 983041   */
   #define  NWDP_LE_MODB_NO_SUCH_ATTRIBUTE   0x000F0002L /* 983042   */
   #define  NWDP_LE_MODB_OBJ_ALREADY_EXISTS  0x000F0003L /* 983043   */

   #define  NWDP_LE_ATR_NOT_IN_SET           0x00100001L /* 1048577  */
   #define  NWDP_LE_ATR_INVALID_VALUE_TYPE   0x00100002L /* 1048578  */
   #define  NWDP_LE_ATR_NOT_SUPPORTED        0x00100003L /* 1048579  */
   #define  NWDP_LE_ATR_VALUE_NOT_FOUND      0x00100004L /* 1048580  */
   #define  NWDP_LE_ATR_BAD_ADDRESS_ITEM     0x00100005L /* 1048581  */
   #define  NWDP_LE_ATR_BAD_CARDORNAMEOROID  0x00100006L /* 1048582  */
   #define  NWDP_LE_ATR_BAD_CARDINAL_OR_OID  0x00100007L /* 1048583  */
   #define  NWDP_LE_ATR_BAD_COLORANT_SET     0x00100008L /* 1048584  */
   #define  NWDP_LE_ATR_BAD_DELIVERY_ADDR    0x00100009L /* 1048585  */
   #define  NWDP_LE_ATR_BAD_DIMENSION        0x0010000AL /* 1048586  */
   #define  NWDP_LE_ATR_BAD_DISTNAME_STRSEQ  0x0010000BL /* 1048587  */
   #define  NWDP_LE_ATR_BAD_DOC_CONTENT      0x0010000CL /* 1048588  */
   #define  NWDP_LE_ATR_BAD_EVENT_OBJ_ITEM   0x0010000DL /* 1048589  */
   #define  NWDP_LE_ATR_BAD_EVENT_OBJ_SET    0x0010000EL /* 1048590  */
   #define  NWDP_LE_ATR_BAD_FINISHING        0x0010000FL /* 1048591  */
   #define  NWDP_LE_ATR_BAD_IDENTIFIER_SET   0x00100010L /* 1048592  */
   #define  NWDP_LE_ATR_BAD_IGNORED_ATTR     0x00100011L /* 1048593  */
   #define  NWDP_LE_ATR_BAD_LOCATIONS        0x00100012L /* 1048594  */
   #define  NWDP_LE_ATR_BAD_MEDIUM_SRC_SIZE  0x00100013L /* 1048595  */
   #define  NWDP_LE_ATR_BAD_NAME_OR_OID      0x00100014L /* 1048596  */
   #define  NWDP_LE_ATR_BAD_NAME_OR_OID_SET  0x00100015L /* 1048597  */
   #define  NWDP_LE_ATR_BAD_NTFY_DELRY_ADDR  0x00100016L /* 1048598  */
   #define  NWDP_LE_ATR_BAD_NMBRS_UP_SPPRTD  0x00100017L /* 1048599  */
   #define  NWDP_LE_ATR_BAD_OBJECT_IDENT     0x00100018L /* 1048600  */
   #define  NWDP_LE_ATR_BAD_PAGE_MEDIA_SLCT  0x00100019L /* 1048601  */
   #define  NWDP_LE_ATR_BAD_PAGE_SELECT      0x0010001AL /* 1048602  */
   #define  NWDP_LE_ATR_BAD_PAGE_SELECT_SEQ  0x0010001BL /* 1048603  */
   #define  NWDP_LE_ATR_BAD_PAGE_SIZE        0x0010001CL /* 1048604  */
   #define  NWDP_LE_ATR_BAD_POS_INT_OR_OID   0x0010001DL /* 1048605  */
   #define  NWDP_LE_ATR_BAD_QUALIFIED_NAME   0x0010001EL /* 1048606  */
   #define  NWDP_LE_ATR_BAD_QUALIFIEDNMESET  0x0010001FL /* 1048607  */
   #define  NWDP_LE_ATR_BAD_RDN_SEQUENCE     0x00100020L /* 1048608  */
   #define  NWDP_LE_ATR_BAD_RESOURCE         0x00100021L /* 1048609  */
   #define  NWDP_LE_ATR_BAD_RESRCE_CNTXTSEQ  0x00100022L /* 1048610  */
   #define  NWDP_LE_ATR_BAD_RESOURCE_PRT_ID  0x00100023L /* 1048611  */
   #define  NWDP_LE_ATR_BAD_XY_DIMENSNS_VAL  0x00100024L /* 1048612  */

   #define  NWDP_LE_RES_NO_NET_ADDR_ATTR     0x00110001L /* 1114113  */
   #define  NWDP_LE_RES_FILE_ZERO_LENGTH     0x00110002L /* 1114114  */
   #define  NWDP_LE_RES_NOT_ENABLED          0x00110003L /* 1114115  */
   #define  NWDP_LE_RES_ANNOTATION_TOO_LONG  0x00110004L /* 1114116  */
   #define  NWDP_LE_RES_NONE_CURRENT         0x00110005L /* 1114117  */
   #define  NWDP_LE_RES_MGR_SEARCH_FAILED    0x00110006L /* 1114118  */

   #define  NWDP_LE_NTFY_NO_NET_ADDR_ATTR    0x00120001L /* 1179649  */
   #define  NWDP_LE_NTFY_EVENT_OBJ_NOT_FND   0x00120002L /* 1179650  */
   #define  NWDP_LE_NTFY_INVALID_PROFILE_ID  0x00120003L /* 1179651  */
   #define  NWDP_LE_NTFY_NO_SUCH_PROFILE     0x00120004L /* 1179652  */
   #define  NWDP_LE_NTFY_NOT_ENABLED         0x00120005L /* 1179653  */

   #define  NWDP_LE_COMPARE_RESULT_LT        0x00140001L /* 1310721  */
   #define  NWDP_LE_COMPARE_RESULT_EQ        0x00140002L /* 1310722  */
   #define  NWDP_LE_COMPARE_RESULT_GT        0x00140003L /* 1310723  */
   #define  NWDP_LE_COMPARE_RESULT_NE        0x00140004L /* 1310724  */

   /* Indicates the otherNDPSErrorReturnPtr is valid */
   #define  NWDP_LE_OTHER_NDPS_ERROR_RETURN  0x00150001L /* 1376257  */

   #define  NWDP_LE_NIOS_INIT_FAILURE        0x00160001L /* 1441793  */
   #define  NWDP_LE_NIOS_GET_SYSTEMDIR_FAIL  0x00160002L /* 1441794  */

   #define  NWDP_LE_INVALID_SLP_URL_FORMAT   0x00170001L /* 1507329  */

   /*
   // Values of the libError field when N_FAILURE or NWDP_RC_WARNING
   // is returned as a function result because an underlying library 
   // failed. These are the Error Categories (EC).
   */
   /*
   // NWDP_EC_CATEGORY_MASK  implies the otherError has a number
   // NWDP_EC_CATEGORY2_MASK implies the otherError,otherError2 have numbers
   // NWDP_EC_CATEGORYSTR_MASK implies otherError has a number, and
   //    otherErrorStrPtr points to a useful, null-terminated string.  
   */
   #define  NWDP_EC_CATEGORY_MASK            0x01000000L /* 16777216 */
   #define  NWDP_EC_CATEGORY2_MASK           0x03000000L /* 16777216 */
   #define  NWDP_EC_CATEGORYSTR_MASK         0x05000000L /* 16777216 */

   #define  NWDP_EC_INVALID_PARAMETER        0x01000001L /* 16777217 */
   #define  NWDP_EC_PARAM_VAL_UNRECOGNIZED   0x01000002L /* 16777218 */
   #define  NWDP_EC_CALLBACK                 0x01000003L /* 16777219 */
   #define  NWDP_EC_STDIO                    0x01000004L /* 16777220 */
   #define  NWDP_EC_NDS                      0x01000005L /* 16777221 */
   #define  NWDP_EC_UNICODE                  0x01000006L /* 16777222 */
   #define  NWDP_EC_INVALID_OPERATOR         0x01000007L /* 16777223 */
   #define  NWDP_EC_PARAM_VAL_UNSUPPORTED    0x01000009L /* 16777225 */
   #define  NWDP_EC_WINDOWS                  0x0100000AL /* 16777226 */
   #define  NWDP_EC_WSA_LAST_ERROR           0x0100000BL /* 16777227 */
   #define  NWDP_EC_SLP_ERROR                0x0100000CL /* 16777228 */
   #define  NWDP_EC_NETWARE_CLIENT_ERROR     0x0100000DL /* 16777229 */


   #define  NWDP_EC_NDS_WITH_POSITION        0x03000005L /* 50331653 */

   #define  NWDP_EC_NO_MEMORY                0x030A0001L /* 50987009 */
   #define  NWDP_EC_ARTIFICIAL_MEM_LIMIT     0x030A0009L /* 50987017 */

   /*
   // Mentions actual error and which NLM can't load, for example.
   */
   #define  NWDP_EC_CANT_LOAD_NLM            0x0500000DL /* 83886093 */
   #define  NWDP_EC_UNRESOLVED_EXTERNAL      0x0500000EL /* 83886094 */
   #define  NWDP_EC_CANT_LOAD_DLL            0x0500000FL /* 83886095 */


   /*
   // These are reserved for the NPSM.NLM to share the accessorRef's
   // error code fields. They are NOT returned by the library.
   */
   #define  NWDP_EC_PSM_GENERATED_OTHER      0x01000008L /* 16777224 */
   #define  NWDP_EC_PSM_GENERATED_OTHER2     0x03000008L /* 50331656 */
   #define  NWDP_EC_PSM_GENERATED_OTHER_STR  0x05000008L /* 83886088 */

   /*
   // Name Service Error categories "other" error is the index of the
   // attribute OID within the set of OIDs.
   */
   #define  NWDP_EC_NSRV_ATTR_NOT_IN_SCHEMA  0x010B0007L /* 17498119 */

   /*
   // PSM Bind returned the name of a different PSM than you asked for.
   */
   #define  NWDP_EC_PSM_BOUND_TO_WRONG_ONE   0x05170001L /* 85393409 */

   /*
   // Bind returned the name of a different Broker than you asked for.
   */
   #define  NWDP_EC_BRK_BOUND_TO_WRONG_ONE   0x05180001L /* 85458945 */
   #define  NWDP_EC_RES_BOUND_TO_WRONG_ONE   0x05180002L /* 85458946 */
   #define  NWDP_EC_SRS_BOUND_TO_WRONG_ONE   0x05180003L /* 85458947 */
   #define  NWDP_EC_NTFY_BOUND_TO_WRONG_ONE  0x05180004L /* 85458948 */

   /*
   // RPC errors and categories
   */
   #define  NWDP_LE_RPC_ERROR_BASE           0x00700000L /* 7340032  */

   #define  NWDP_LE_RPC_SUCCESS              0x00700000L /* 7340032 */
   #define  NWDP_LE_RPC_CANTENCODEARGS       0x00700001L /* 7340033 */
   #define  NWDP_LE_RPC_CANTDECODERES        0x00700002L /* 7340034 */
   #define  NWDP_LE_RPC_TIMEDOUT             0x00700005L /* 7340037 */
   #define  NWDP_LE_RPC_PROGUNAVAIL          0x00700008L /* 7340040 */
   #define  NWDP_LE_RPC_PROCUNAVAIL          0x0070000AL /* 7340042 */
   #define  NWDP_LE_RPC_CANTDECODEARGS       0x0070000BL /* 7340043 */
   #define  NWDP_LE_RPC_SYSTEMERROR          0x0070000CL /* 7340044 */
   #define  NWDP_LE_RPC_UNKNOWNHOST          0x0070000DL /* 7340045 */
   #define  NWDP_LE_RPC_RPCBFAILURE          0x0070000EL /* 7340046 */
   #define  NWDP_LE_RPC_PROGNOTREGISTERED    0x0070000FL /* 7340047 */
   #define  NWDP_LE_RPC_FAILED               0x00700010L /* 7340048 */
   #define  NWDP_LE_RPC_UNKNOWNPROTO         0x00700011L /* 7340049 */
   #define  NWDP_LE_RPC_UNKNOWNADDR          0x00700013L /* 7340051 */
   #define  NWDP_LE_RPC_NOBROADCAST          0x00700015L /* 7340053 */

   /*
   // otherError defined.
   */
   #define  NWDP_EC_RPC_AUTHERROR            0x01700007L /* 24117255 */
   #define  NWDP_EC_RPC_N2AXLATEFAILURE      0x01700016L /* 24117270 */

   /*
   // otherError and otherError2 both defined.
   */
   #define  NWDP_EC_RPC_CANTSEND             0x03700003L /* 24117251 */
   #define  NWDP_EC_RPC_CANTRECV             0x03700004L /* 24117252 */
   #define  NWDP_EC_RPC_VERSMISMATCH         0x03700006L /* 24117254 */
   #define  NWDP_EC_RPC_PROGVERSMISMATCH     0x03700009L /* 24117257 */
   #define  NWDP_EC_RPC_INTR                 0x03700012L /* 24117266 */
   /*
   // The values for NWDP_EC_RPC_TLIERROR (0x03700014) come from tiuser.h 
   */
   #define  NWDP_EC_RPC_TLIERROR             0x03700014L /* 24117268 */
   #define  NWDP_EC_RPC_UDERROR              0x03700017L /* 24117271 */
   #define  NWDP_EC_RPC_CANCELED             0x03700019L /* 24117273 */

   /*
   // Values of the otherError field when NWDP_RC_WARNING
   // is returned as a function result and the error category found in the
   // libError field matches one of these categories are all results of
   // subtracting the first parameter from the second. The otherError
   // field should be evaluated as an nint32.
   */
   #define  NWDP_EC_COMPARE_RESULT_LT        0x01140001L /* 18087937 */
   #define  NWDP_EC_COMPARE_RESULT_EQ        0x01140002L /* 18087938 */
   #define  NWDP_EC_COMPARE_RESULT_GT        0x01140003L /* 18087939 */


   /*
   // Values of the otherError field when N_FAILURE or NWDP_RC_WARNING
   // is returned as a function result and the error category found in the
   // libError field matches one of these categories. 
   // These are the Other Error (OE) values.
   */

   /*
   // Broker trouble: otherError and otherError2 both defined.
   */
   #define  NWDP_EC_BROKER_RESULT           0x03060001L /* 50724865 */
   /*
   // Other Error values returned from the Broker NLM 
   */
   #define  NWDP_OE_BK_OUT_OF_MEMORY        0xFFFFFC18L /* -1000    */
   #define  NWDP_OE_BK_BAD_NETWARE_VERSION  0xFFFFFC17L /* -1001    */
   #define  NWDP_OE_BK_WRONG_CMD_LINE_ARGS  0xFFFFFC16L /* -1002    */
   #define  NWDP_OE_BK_BROKER_NAME_NOT_GIVN 0xFFFFFC15L /* -1003    */
   #define  NWDP_OE_BK_NOT_BROKER_CLASS     0xFFFFFC14L /* -1004    */
   #define  NWDP_OE_BK_INVALID_BROKER_PWORD 0xFFFFFC13L /* -1005    */
   #define  NWDP_OE_BK_INVALID_BROKER_NAME  0xFFFFFC12L /* -1006    */
   #define  NWDP_OE_BK_FAILED_TO_CRTE_THRED 0xFFFFFC11L /* -1007    */
   #define  NWDP_OE_BK_FAILED_TO_INIT_NUT   0xFFFFFC10L /* -1008    */
   #define  NWDP_OE_BK_FAILED_TO_GET_MSGS   0xFFFFFC0FL /* -1009    */
   #define  NWDP_OE_BK_FAILED_TO_ALLOC_RES  0xFFFFFC0EL /* -1010    */
   #define  NWDP_OE_BK_SVC_MUST_BE_FULL_DIS 0xFFFFFC0DL /* -1011    */
   #define  NWDP_OE_BK_UNINITIALIZED_MODULE 0xFFFFFC0CL /* -1012    */
   #define  NWDP_OE_BK_DS_VAL_SIZE_TOO_LARG 0xFFFFFC0BL /* -1013    */
   #define  NWDP_OE_BK_NO_ATTRIBUTE_VALUES  0xFFFFFC0AL /* -1014    */
   #define  NWDP_OE_BK_UNKNOWN_SESSION      0xFFFFFC09L /* -1015    */
   #define  NWDP_OE_BK_SERVICE_DISABLED     0xFFFFFC08L /* -1016    */
   #define  NWDP_OE_BK_UNKNOWN_MODIFY_OPER  0xFFFFFC07L /* -1017    */
   #define  NWDP_OE_BK_INVALID_ARGUMENTS    0xFFFFFC06L /* -1018    */
   #define  NWDP_OE_BK_DUPLICATE_SESSION_ID 0xFFFFFC05L /* -1019    */
   #define  NWDP_OE_BK_UNKNOWN_SERVICE      0xFFFFFC04L /* -1020    */
   #define  NWDP_OE_BK_SRVC_ALREADY_ENABLED 0xFFFFFC03L /* -1021    */
   #define  NWDP_OE_BK_SRVC_ALREADY_DISABLD 0xFFFFFC02L /* -1022    */
   #define  NWDP_OE_BK_INVALID_CREDENTIAL   0xFFFFFC01L /* -1023    */
   #define  NWDP_OE_BK_UNKNOWN_DESIGNATOR   0xFFFFFC00L /* -1024    */
   #define  NWDP_OE_BK_FAIL_MAKE_CHG_PERMNT 0xFFFFFBFFL /* -1025    */
   #define  NWDP_OE_BK_NOT_ADMIN_TYPE_SESN  0xFFFFFBFEL /* -1026    */
   #define  NWDP_OE_BK_OPTION_NOT_SUPPORTED 0xFFFFFBFDL /* -1027    */
   #define  NWDP_OE_BK_NO_EFFECTIVE_RIGHTS  0xFFFFFBFCL /* -1028    */
   #define  NWDP_OE_BK_COULD_NOT_FIND_FILE  0xFFFFFBFBL /* -1029    */
   #define  NWDP_OE_BK_ERROR_READING_FILE   0xFFFFFBFAL /* -1030    */
   #define  NWDP_OE_BK_NOT_NLM_FILE_FORMAT  0xFFFFFBF9L /* -1031    */
   #define  NWDP_OE_BK_WRONG_NLM_FILE_VER   0xFFFFFBF8L /* -1032    */
   #define  NWDP_OE_BK_REENTRANT_INIT_FAIL  0xFFFFFBF7L /* -1033    */
   #define  NWDP_OE_BK_ALREADY_IN_PROGRESS  0xFFFFFBF6L /* -1034    */
   #define  NWDP_OE_BK_INITIALIZE_FAILURE   0xFFFFFBF5L /* -1035    */
   #define  NWDP_OE_BK_INCONSISTNT_FILE_FMT 0xFFFFFBF4L /* -1036    */
   #define  NWDP_OE_BK_CANT_LOAD_AT_STARTUP 0xFFFFFBF3L /* -1037    */
   #define  NWDP_OE_BK_AUTO_MODULS_NOT_LOAD 0xFFFFFBF2L /* -1038    */
   #define  NWDP_OE_BK_UNRESOLVED_EXTERNAL  0xFFFFFBF1L /* -1039    */
   #define  NWDP_OE_BK_PUBLIC_ALREADY_DEFND 0xFFFFFBF0L /* -1040    */
   #define  NWDP_OE_BK_OTHER_BRKR_USING_OBJ 0xFFFFFBEFL /* -1041    */
   #define  NWDP_OE_BK_SRVC_FAILED_TO_INIT  0xFFFFFBEEL /* -1042    */

   /*
   // Service Registry trouble: otherError and otherError2 both defined.
   */
   #define  NWDP_EC_REGISTRY_RESULT         0x03060002L /* 50724866 */
   /*
   // Other Error values returned from the Service Registry NLM 
   */
   #define  NWDP_OE_RG_OUT_OF_MEMORY        0xFFFFFBB4L /* -1100    */
   #define  NWDP_OE_RG_BAD_NETWARE_VERSION  0xFFFFFBB3L /* -1101    */
   #define  NWDP_OE_RG_FAIL_CREATE_CONTEXT  0xFFFFFBB2L /* -1102    */
   #define  NWDP_OE_RG_FAIL_LOGIN           0xFFFFFBB1L /* -1103    */
   #define  NWDP_OE_RG_FAIL_CREATE_THREAD   0xFFFFFBB0L /* -1104    */
   #define  NWDP_OE_RG_FAIL_GET_MSGS        0xFFFFFBAFL /* -1105    */
   #define  NWDP_OE_RG_SVC_MUST_BE_FULL_DIS 0xFFFFFBAEL /* -1106    */
   #define  NWDP_OE_RG_DS_VAL_SIZE_TOO_LARG 0xFFFFFBADL /* -1107    */
   #define  NWDP_OE_RG_NO_ATTRIBUTE_VALUES  0xFFFFFBACL /* -1108    */
   #define  NWDP_OE_RG_UNKNOWN_SESSION      0xFFFFFBABL /* -1109    */
   #define  NWDP_OE_RG_SERVICE_DISABLED     0xFFFFFBAAL /* -1110    */
   #define  NWDP_OE_RG_UNKNOWN_MODIFY_OPER  0xFFFFFBA9L /* -1111    */
   #define  NWDP_OE_RG_CANT_START_ADVERTISE 0xFFFFFBA8L /* -1112    */
   #define  NWDP_OE_RG_DUP_SERVER_ENTRY     0xFFFFFBA7L /* -1113    */
   #define  NWDP_OE_RG_CANT_BIND_2_REGISTRY 0xFFFFFBA6L /* -1114    */
   #define  NWDP_OE_RG_CANT_CREATE_CLIENT   0xFFFFFBA5L /* -1115    */
   #define  NWDP_OE_RG_INVALID_ARGUMENTS    0xFFFFFBA4L /* -1116    */
   #define  NWDP_OE_RG_DUPLICATE_SESSION_ID 0xFFFFFBA3L /* -1117    */
   #define  NWDP_OE_RG_UNKNOWN_SERVER_ENTRY 0xFFFFFBA2L /* -1118    */
   #define  NWDP_OE_RG_INVALID_CREDENTIAL   0xFFFFFBA1L /* -1119    */
   #define  NWDP_OE_RG_REGIST_TYPE_SESN     0xFFFFFBA0L /* -1120    */
   #define  NWDP_OE_RG_SERVER_TYPE_SESN     0xFFFFFB9FL /* -1121    */
   #define  NWDP_OE_RG_NOT_SERVER_TYPE_SESN 0xFFFFFB9EL /* -1122    */
   #define  NWDP_OE_RG_NOT_REGIST_TYPE_SESN 0xFFFFFB9DL /* -1123    */
   #define  NWDP_OE_RG_UNKNOWN_DESIGNATOR   0xFFFFFB9CL /* -1124    */
   #define  NWDP_OE_RG_OPTION_NOT_SUPPORTED 0xFFFFFB9BL /* -1125    */
   #define  NWDP_OE_RG_NOT_IN_LST_ITERATION 0xFFFFFB9AL /* -1126    */
   #define  NWDP_OE_RG_INVLD_CONTNUATN_HNDL 0xFFFFFB99L /* -1127    */

   /*
   // Notification Service trouble: otherError and otherError2 both defined.
   */
   #define  NWDP_EC_NOTIFY_RESULT           0x03060003L /* 50724867 */
   /*
   // Other Error values returned from the Nofification Service NLM 
   */
   #define  NWDP_OE_NF_OUT_OF_MEMORY        0xFFFFFB50L /* -1200    */
   #define  NWDP_OE_NF_BAD_NETWARE_VERSION  0xFFFFFB4FL /* -1201    */
   #define  NWDP_OE_NF_FAIL_CREATE_THREAD   0xFFFFFB4EL /* -1202    */
   #define  NWDP_OE_NF_FAIL_GET_MSGS        0xFFFFFB4DL /* -1203    */
   #define  NWDP_OE_NF_FAIL_CREATE_CONTEXT  0xFFFFFB4CL /* -1204    */
   #define  NWDP_OE_NF_FAIL_LOGIN           0xFFFFFB4BL /* -1205    */
   #define  NWDP_OE_NF_SVC_MUST_BE_FULL_DIS 0xFFFFFB4AL /* -1206    */
   #define  NWDP_OE_NF_DS_VAL_SIZE_TOO_LARG 0xFFFFFB49L /* -1207    */
   #define  NWDP_OE_NF_NO_ATTRIBUTE_VALUES  0xFFFFFB48L /* -1208    */
   #define  NWDP_OE_NF_UNKNOWN_SESSION      0xFFFFFB47L /* -1209    */
   #define  NWDP_OE_NF_UNKNOWN_NOTIFY_PROF  0xFFFFFB46L /* -1210    */
   #define  NWDP_OE_NF_ERROR_READING_FILE   0xFFFFFB45L /* -1211    */
   #define  NWDP_OE_NF_ERROR_WRITING_FILE   0xFFFFFB44L /* -1212    */
   #define  NWDP_OE_NF_WRONG_NOTIFY_DB_VERS 0xFFFFFB43L /* -1213    */
   #define  NWDP_OE_NF_CORRUPTED_NOTIFY_DB  0xFFFFFB42L /* -1214    */
   #define  NWDP_OE_NF_UNKNOWN_EVENT_OID    0xFFFFFB41L /* -1215    */
   #define  NWDP_OE_NF_METHOD_ALREADY_INST  0xFFFFFB40L /* -1216    */
   #define  NWDP_OE_NF_UNKNOWN_METHOD       0xFFFFFB3FL /* -1217    */
   #define  NWDP_OE_NF_SERVICE_DISABLED     0xFFFFFB3EL /* -1218    */
   #define  NWDP_OE_NF_UNKNOWN_MODIFY_OP    0xFFFFFB3DL /* -1219    */
   #define  NWDP_OE_NF_OUT_OF_NOTIFY_ENTRYS 0xFFFFFB3CL /* -1220    */
   #define  NWDP_OE_NF_UNKNOWN_LANGUAGE_ID  0xFFFFFB3BL /* -1221    */
   #define  NWDP_OE_NF_NOTIFY_QUEUE_EMPTY   0xFFFFFB3AL /* -1222    */
   #define  NWDP_OE_NF_CANT_LOAD_DELVR_METH 0xFFFFFB39L /* -1223    */
   #define  NWDP_OE_NF_INVALID_ARGUMENTS    0xFFFFFB38L /* -1224    */
   #define  NWDP_OE_NF_DUPLICATE_SESSION_ID 0xFFFFFB37L /* -1225    */
   #define  NWDP_OE_NF_INVALID_CREDENTIAL   0xFFFFFB36L /* -1226    */
   #define  NWDP_OE_NF_UNKNOWN_CHOICE       0xFFFFFB35L /* -1227    */
   #define  NWDP_OE_NF_UNKNOWN_ATTR_VALUE   0xFFFFFB34L /* -1228    */
   #define  NWDP_OE_NF_ERROR_WRITING_DB     0xFFFFFB33L /* -1229    */
   #define  NWDP_OE_NF_UNKNOWN_OBJECT_ID    0xFFFFFB32L /* -1230    */
   #define  NWDP_OE_NF_UNKNOWN_DESIGNATOR   0xFFFFFB31L /* -1231    */
   #define  NWDP_OE_NF_FAIL_MAKE_CHG_PERMNT 0xFFFFFB30L /* -1232    */
   #define  NWDP_OE_NF_UI_NOT_SUPPORTED     0xFFFFFB2FL /* -1233    */
   #define  NWDP_OE_NF_NOT_SUPPLY_TYPE_SESN 0xFFFFFB2EL /* -1234    */
   #define  NWDP_OE_NF_NOT_ADMIN_TYPE_SESN  0xFFFFFB2DL /* -1235    */
   #define  NWDP_OE_NF_NO_SRVC_REGIST_AVAIL 0xFFFFFB2CL /* -1236    */
   #define  NWDP_OE_NF_FAIL_TO_REG_W_ANY_SR 0xFFFFFB2BL /* -1237    */
   #define  NWDP_OE_NF_EMPTY_EVENT_OBJ_SET  0xFFFFFB2AL /* -1238    */
   #define  NWDP_OE_NF_UNKNOWN_NTFY_HANDLE  0xFFFFFB29L /* -1239    */
   #define  NWDP_OE_NF_OPTION_NOT_SUPPORTED 0xFFFFFB28L /* -1240    */
   #define  NWDP_OE_NF_UNKNOWN_RPC_SESSION  0xFFFFFB27L /* -1241    */
   #define  NWDP_OE_NF_INITIALIZATION_ERROR 0xFFFFFB26L /* -1242    */
   #define  NWDP_OE_NF_NO_EFFECTIVE_RIGHTS  0xFFFFFB25L /* -1243    */
   #define  NWDP_OE_NF_NO_PERSISTENT_STORAG 0xFFFFFB24L /* -1244    */
   #define  NWDP_OE_NF_BAD_METHOD_FILENAME  0xFFFFFB23L /* -1245    */
   #define  NWDP_OE_NF_UNKNOWN_CONT_HANDLE  0xFFFFFB22L /* -1246    */
   #define  NWDP_OE_NF_INVALID_CONT_HANDLE  0xFFFFFB21L /* -1247    */
   #define  NWDP_OE_NF_COULD_NOT_FIND_FILE  0xFFFFFB20L /* -1248    */
   #define  NWDP_OE_NF_L_ERROR_READING_FILE 0xFFFFFB1FL /* -1249    */
   #define  NWDP_OE_NF_NOT_NLM_FILE_FORMAT  0xFFFFFB1EL /* -1250    */
   #define  NWDP_OE_NF_WRONG_NLM_FILE_VER   0xFFFFFB1DL /* -1251    */
   #define  NWDP_OE_NF_REENTRANT_INIT_FAIL  0xFFFFFB1CL /* -1252    */
   #define  NWDP_OE_NF_ALREADY_IN_PROGRESS  0xFFFFFB1BL /* -1253    */
   #define  NWDP_OE_NF_INITIALIZE_FAILURE   0xFFFFFB1AL /* -1254    */
   #define  NWDP_OE_NF_INCONSISTNT_FILE_FMT 0xFFFFFB19L /* -1255    */
   #define  NWDP_OE_NF_CANT_LOAD_AT_STARTUP 0xFFFFFB18L /* -1256    */
   #define  NWDP_OE_NF_AUTO_MODULS_NOT_LOAD 0xFFFFFB17L /* -1257    */
   #define  NWDP_OE_NF_UNRESOLVED_EXTERNAL  0xFFFFFB16L /* -1258    */
   #define  NWDP_OE_NF_PUBLIC_ALREADY_DEFND 0xFFFFFB15L /* -1259    */
   #define  NWDP_OE_NF_USING_UNKNOWN_METHDS 0xFFFFFB14L /* -1260    */
   #define  NWDP_OE_NF_SRVC_NOT_FULL_ENABLD 0xFFFFFB13L /* -1261    */
   #define  NWDP_OE_NF_FOREIGN_NDS_TREE_NAM 0xFFFFFB12L /* -1262    */
   #define  NWDP_OE_NF_DLVYMETH_REJCTD_ADDR 0xFFFFFB11L /* -1263    */
   #define  NWDP_OE_NF_UNSUPRT_DLVYADDRTYPE 0xFFFFFB10L /* -1264    */
   #define  NWDP_OE_NF_USR_OBJ_NO_DEFLTSERV 0xFFFFFB0FL /* -1265    */
   #define  NWDP_OE_NF_FAILED_TO_SEND_NOTIF 0xFFFFFB0EL /* -1266    */
   #define  NWDP_OE_NF_BAD_VOLUME_IN_ADDR   0xFFFFFB0DL /* -1267    */
   #define  NWDP_OE_NF_BROKER_NO_FILE_RIGHT 0xFFFFFB0CL /* -1268    */
   #define  NWDP_OE_NF_MAX_METHDS_SUPPORTED 0xFFFFFB0BL /* -1269    */
   #define  NWDP_OE_NF_NO_FILTER_PROVIDED   0xFFFFFB0AL /* -1270    */

   /*
   // Resource Manager trouble: otherError and otherError2 both defined.
   */
   #define  NWDP_EC_RESMAN_RESULT2          0x03060005L /* 50724869 */

   /*
   // Resource Manager trouble: only otherError defined.
   */
   #define  NWDP_EC_RESMAN_RESULT           0x01060004L /* 17170436 */
   /*
   // Other Error values returned from the Resource Manager NLM 
   */
   #define  NWDP_OE_RM_OUT_OF_MEMORY        0xFFFFFC7CL /* -900     */
   #define  NWDP_OE_RM_BAD_NETWARE_VERSION  0xFFFFFC7BL /* -901     */
   #define  NWDP_OE_RM_WRONG_CMD_LINE_ARGS  0xFFFFFC7AL /* -902     */
   #define  NWDP_OE_RM_BROKER_NAME_NOT_GIVN 0xFFFFFC79L /* -903     */
   #define  NWDP_OE_RM_INVALID_BROKER_PWORD 0xFFFFFC78L /* -904     */
   #define  NWDP_OE_RM_INVALID_BROKER_NAME  0xFFFFFC77L /* -905     */
   #define  NWDP_OE_RM_FAILED_TO_CRTE_THRED 0xFFFFFC76L /* -906     */
   #define  NWDP_OE_RM_SVC_MUST_BE_FULL_DIS 0xFFFFFC75L /* -907     */
   #define  NWDP_OE_RM_DS_VAL_SIZE_TOO_LARG 0xFFFFFC74L /* -908     */
   #define  NWDP_OE_RM_NO_ATTRIBUTE_VALUES  0xFFFFFC73L /* -909     */
   #define  NWDP_OE_RM_UNKNOWN_SESSION      0xFFFFFC72L /* -910     */
   #define  NWDP_OE_RM_ERROR_READING_FILE   0xFFFFFC71L /* -911     */
   #define  NWDP_OE_RM_ERROR_WRITING_FILE   0xFFFFFC70L /* -912     */
   #define  NWDP_OE_RM_SERVICE_DISABLED     0xFFFFFC6FL /* -913     */
   #define  NWDP_OE_RM_UNKNOWN_MODIFY_OPER  0xFFFFFC6EL /* -914     */
   #define  NWDP_OE_RM_DUPLICATE_SESSION_ID 0xFFFFFC6DL /* -915     */
   #define  NWDP_OE_RM_INVALID_CREDENTIAL   0xFFFFFC6CL /* -916     */
   #define  NWDP_OE_RM_NO_SRVC_REGIST_AVAIL 0xFFFFFC6BL /* -917     */
   #define  NWDP_OE_RM_FAIL_TO_REG_W_ANY_SR 0xFFFFFC6AL /* -918     */
   #define  NWDP_OE_RM_FAIL_TO_GET_MSGS     0xFFFFFC69L /* -919     */
   #define  NWDP_OE_RM_FAIL_TO_CRTE_CONTEXT 0xFFFFFC68L /* -920     */
   #define  NWDP_OE_RM_FAIL_TO_LOGIN        0xFFFFFC67L /* -921     */

   #define  NWDP_OE_RM_NPD_FILE_GEN_ERR     0xFFFFFC66L /* -922     */
   #define  NWDP_OE_RM_INF_FILE_FORMAT_ERR  0xFFFFFC65L /* -923     */
   #define  NWDP_OE_RM_NO_PRT_TYPE_IN_INF   0xFFFFFC64L /* -924     */
   #define  NWDP_OE_RM_NO_INF_FILES_PRESENT 0xFFFFFC63L /* -925     */
   #define  NWDP_OE_RM_FILE_OPEN_ERROR		  0xFFFFFC62L /* -926     */
   #define  NWDP_OE_RM_READ_FILE_ERROR		  0xFFFFFC61L /* -927     */
   #define  NWDP_OE_RM_WRITE_FILE_ERROR	  0xFFFFFC60L /* -928     */
   #define  NWDP_OE_RM_RESRC_TYPE_INVALID   0xFFFFFC5FL /* -929     */
   #define  NWDP_OE_RM_NO_SUCH_FILENAME     0xFFFFFC5EL /* -930     */
   #define  NWDP_OE_RM_BANR_TYPE_INVALID    0xFFFFFC5DL /* -931     */
   #define  NWDP_OE_RM_LIST_TYPE_UNKNOWN    0xFFFFFC5CL /* -932     */
   #define  NWDP_OE_RM_OS_NOT_SUPPORTED     0xFFFFFC5BL /* -933     */
   #define  NWDP_OE_RM_NO_BANR_FILES_PRESNT 0xFFFFFC5AL /* -934     */
   #define  NWDP_OE_RM_PRN_DEF_TYPE_UNKNOWN 0xFFFFFC59L /* -935     */
   #define  NWDP_OE_RM_NO_PRN_TYPES_IN_LIST 0xFFFFFC58L /* -936     */
   #define  NWDP_OE_RM_OPTION_NOT_SUPPORTED 0xFFFFFC57L /* -937     */
   #define  NWDP_OE_RM_UNICODE_CONV_ERR     0xFFFFFC56L /* -938     */

   #define  NWDP_OE_RM_INVALID_ARGUMENTS    0xFFFFFC55L /* -939     */
   #define  NWDP_OE_RM_INITIALIZATION_ERROR 0xFFFFFC54L /* -940     */
   #define  NWDP_OE_RM_NO_SRV_REG_AVAILABLE 0xFFFFFC53L /* -941     */
   #define  NWDP_OE_RM_FAIL_RGSTR_TO_ANY_SR 0xFFFFFC52L /* -942     */
   #define  NWDP_OE_RM_UNKNOWN_DESIGNATOR   0xFFFFFC51L /* -943     */
   #define  NWDP_OE_RM_NOT_ADMIN_SESSION    0xFFFFFC50L /* -944     */
   #define  NWDP_OE_RM_NO_EFFECTIVE_RIGHTS  0xFFFFFC4FL /* -945     */
   #define  NWDP_OE_RM_BAD_FILE_ATTRIBUTE   0xFFFFFC4EL /* -946     */
   #define  NWDP_OE_RM_DID_FORMAT_ERROR     0xFFFFFC4DL /* -947     */
   #define  NWDP_OE_RM_UNKNOWN_RPC_SESSION  0xFFFFFC4CL /* -948     */
   #define  NWDP_OE_RM_SESSN_BEING_REMOVED  0xFFFFFC4BL /* -949     */

   #define  NWDP_OE_RM_FMGR_IO_ERROR        0xFFFFFC49L /*  -951    */
   #define  NWDP_OE_RM_FMGR_REENTRANCY      0xFFFFFC48L /*  -952    */
   #define  NWDP_OE_RM_FMGR_SEQ_ERROR       0xFFFFFC47L /*  -953    */
   #define  NWDP_OE_RM_FMGR_CRPT_INDEX_FILE 0xFFFFFC46L /*  -954    */
   #define  NWDP_OE_RM_FMGR_NO_SUCH_FONT    0xFFFFFC45L /*  -955    */
   #define  NWDP_OE_RM_FMGR_NOT_INITIALIZED 0xFFFFFC44L /*  -956    */
   #define  NWDP_OE_RM_FMGR_SYSTEM_ERROR    0xFFFFFC43L /*  -957    */
   #define  NWDP_OE_RM_FMGR_BAD_PARM        0xFFFFFC42L /*  -958    */
   #define  NWDP_OE_RM_FMGR_PATH_TOO_LONG   0xFFFFFC41L /*  -959    */
   #define  NWDP_OE_RM_FMGR_FAILURE         0xFFFFFC40L /*  -960    */

   #define  NWDP_OE_RM_DUP_TIRPC_SESSION    0xFFFFFC3FL /* -961     */
   #define  NWDP_OE_RM_CONN_LOST_RMS_DATA   0xFFFFFC3EL /* -962     */

/* Macro Definitions */

   /*
   // These six macros give basic access to the error data.
   */
#define NWDPLibErrorMac(accRef)    (((NWDPAccessorRef)accRef)->libError)
#define NWDPOtherErrorMac(accRef)  (((NWDPAccessorRef)accRef)->otherError)
#define NWDPOtherError2Mac(accRef) (((NWDPAccessorRef)accRef)->otherError2)
#define NWDPOtherErrorStrPtrMac(accRef) \
   (((NWDPAccessorRef)accRef)->otherErrorStrPtr)
#define NWDPErrorLineMac(accRef)   (((NWDPAccessorRef)accRef)->errorLine)
#define NWDPErrorModuleMac(accRef) (((NWDPAccessorRef)accRef)->errorModule)
   /*
   // These macros are used in Callback routines to report errors.
   // Invoke them and return N_FAILURE.
   */
#if defined (N_DEBUG)
#define NWDPModuleNameMac N_INTERN_VAR pnstr moduleNamePtrMGbl = __FILE__;
#define NWDPReportCallbackCancelMac(accRef)                \
(                                                          \
   NWDPLibErrorMac(accRef)          = NWDP_LE_CANCEL_LIST, \
   NWDPOtherErrorMac(accRef)        = 0,                   \
   NWDPOtherError2Mac(accRef)       = 0,                   \
   *NWDPOtherErrorStrPtrMac(accRef) = '\0',                \
   NWDPErrorLineMac(accRef)         = __LINE__,            \
   strcpy(NWDPErrorModuleMac(accRef),moduleNamePtrMGbl)    \
)

#define NWDPReportCallbackErrorMac(accRef,error)       \
(                                                      \
   NWDPLibErrorMac(accRef)          = NWDP_EC_CALLBACK,\
   NWDPOtherErrorMac(accRef)        = error,           \
   NWDPOtherError2Mac(accRef)       = 0,               \
   *NWDPOtherErrorStrPtrMac(accRef) = '\0',            \
   NWDPErrorLineMac(accRef)         = __LINE__,        \
   strcpy(NWDPErrorModuleMac(accRef),moduleNamePtrMGbl)\
)

#define NWDPReportCallbackOtherMac(accRef,errCategory,otherError)\
(                                                                \
   NWDPLibErrorMac(accRef)          = errCategory,               \
   NWDPOtherErrorMac(accRef)        = otherError,                \
   NWDPOtherError2Mac(accRef)       = 0,                         \
   *NWDPOtherErrorStrPtrMac(accRef) = '\0',                      \
   NWDPErrorLineMac(accRef)         = __LINE__,                  \
   strcpy(NWDPErrorModuleMac(accRef),moduleNamePtrMGbl)          \
)
#define NWDPReportCallbackOther2Mac(accRef,errCategory,otherError,\
   otherError2)                                                   \
(                                                                 \
   NWDPLibErrorMac(accRef)          = errCategory,                \
   NWDPOtherErrorMac(accRef)        = otherError,                 \
   NWDPOtherError2Mac(accRef)       = otherError2,                \
   *NWDPOtherErrorStrPtrMac(accRef) = '\0',                       \
   NWDPErrorLineMac(accRef)         = __LINE__,                   \
   strcpy(NWDPErrorModuleMac(accRef),moduleNamePtrMGbl)           \
)
#define NWDPReportCallbackOtherStrMac(accRef,errCategory,otherError, \
   otherErrorStr)                                                    \
(                                                                    \
   NWDPLibErrorMac(accRef)    = errCategory,                         \
   NWDPOtherErrorMac(accRef)  = otherError,                          \
   NWDPOtherError2Mac(accRef) = 0,                                   \
   strncpy(NWDPOtherErrorStrPtrMac(accRef),otherErrorStr,80),        \
   NWDPOtherErrorStrPtrMac(accRef)[79] = '\0'                        \
   NWDPErrorLineMac(accRef)   = __LINE__,                            \
   strcpy(NWDPErrorModuleMac(accRef),moduleNamePtrMGbl)              \
)
#else
#define NWDPModuleNameMac
#define NWDPReportCallbackCancelMac(accRef)         \
(                                                   \
   NWDPLibErrorMac(accRef)   = NWDP_LE_CANCEL_LIST  \
)

#define NWDPReportCallbackErrorMac(accRef,error) \
(                                                \
   NWDPLibErrorMac(accRef)   = NWDP_EC_CALLBACK, \
   NWDPOtherErrorMac(accRef) = error             \
)

#define NWDPReportCallbackOtherMac(accRef,errCategory,otherError)\
(                                                                \
   NWDPLibErrorMac(accRef)   = errCategory,                      \
   NWDPOtherErrorMac(accRef) = otherError                        \
)
#define NWDPReportCallbackOther2Mac(accRef,errCategory,otherError,\
   otherError2)                                                   \
(                                                                 \
   NWDPLibErrorMac(accRef)    = errCategory,                      \
   NWDPOtherErrorMac(accRef)  = otherError,                       \
   NWDPOtherError2Mac(accRef) = otherError2                       \
)
#define NWDPReportCallbackOtherStrMac(accRef,errCategory,otherError, \
   otherErrorStr)                                                    \
(                                                                    \
   NWDPLibErrorMac(accRef)   = errCategory,                          \
   NWDPOtherErrorMac(accRef) = otherError,                           \
   strncpy(NWDPOtherErrorStrPtrMac(accRef),otherErrorStr,80),        \
   NWDPOtherErrorStrPtrMac(accRef)[79] = '\0'                        \
)
#endif /* N_DEBUG */

#define NWDPDisplayErrorMac(accRef) NWDPLibDisplayError(accRef)

/* Type Definitions */

/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */

#else /* NWDP_ERR_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_err.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_ERR_H */

