/*
//ͻ
// (c) 1995-1998 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_NSR.H                                           
//͹
// Library VeRsIoN=1.1.0                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_NSR_H )
   #define NWDP_NSR_H

/* Standard Library Header Includes */

/* Header Includes */
   #if !defined(NWDP_LIB_H)
      #include <nwdp_lib.h>
   #endif
   #if !defined(NWDP_OID_H)
      #include <nwdp_oid.h>
   #endif
   #if !defined(NWDP_ATR_H)
      #include <nwdp_atr.h>
   #endif

/* Manifest Constant Definitions */

   #define NWDP_NSRV_OBJECT_NAME_CHARS  64
   #define NWDP_NSRV_OBJECT_NAME_BYTES  ((NWDP_NSRV_OBJECT_NAME_CHARS+1)*2)

   #if !defined(NWDP_NSRV_MAX_DN_CHARS)
      #define NWDP_NSRV_MAX_DN_CHARS          256
      #define NWDP_NSRV_MAX_DN_BYTES \
            ((NWDP_NSRV_MAX_DN_CHARS+1)*2)

      #define NWDP_NSRV_MAX_TREE_CHARS        32
      #define NWDP_NSRV_MAX_TREE_BYTES \
            ((NWDP_NSRV_MAX_TREE_CHARS+1)*2)
   #endif

   /*
   // Broker creation flags
   */
   #define NWDP_NSRV_FLG_ENABLE_REGIST_SVC   0x00000001L
   #define NWDP_NSRV_FLG_ENABLE_RESMAN_SVC   0x00000002L
   #define NWDP_NSRV_FLG_ENABLE_NOTIFY_SVC   0x00000004L
   
   /*
   // Object Removal Flags
   */
   #define NWDP_NSRV_FLG_DONT_DEL_OBJECT     0x00000001L

/* Macro Definitions */

/* Type Definitions */
#define N_PACK_1
#include <npackon.h>

   /*
   // Object Types which will be available through this API
   */
   typedef enum NWDPNSrvObjType_T
   {
      NWDP_NSRV_OT_ANY_MASK            = -1,

      NWDP_NSRV_OT_BROKER              =  1,
      NWDP_NSRV_OT_PRINTER             =  2,
      NWDP_NSRV_OT_MANAGER             =  4,
      NWDP_NSRV_OT_ORG_OR_OU           =  8
   } NWDPNSrvObjType, N_FAR *pNWDPNSrvObjType;

   typedef struct 
   {
      NWDPNSrvObjType   objectType;
      nchar16           objectName16[ NWDP_NSRV_OBJECT_NAME_CHARS + 1];
   } NWDPNSrvObjListItem, N_FAR *pNWDPNSrvObjListItem;

   typedef enum NWDPNSrvRoleFlag_T
   {
      NWDP_NSRV_RF_ALL_ROLES           = -1,

      NWDP_NSRV_RF_MANAGER             =  1,
      NWDP_NSRV_RF_OPERATOR            =  2,
      NWDP_NSRV_RF_USER                =  4,
      NWDP_NSRV_RF_ACCOUNTANT          =  8
   } NWDPNSrvRoleFlag, N_FAR *pNWDPNSrvRoleFlag;

#include <npackoff.h>

/* Callback Definitions */

 N_TYPEDEF_CALLBACK(nint,
NWDPNSrvObjListCallback)(
   NWDPAccessorRef      accessorRef,
   nparam               callerDefinedParam,
   nint                 totalCallsToBeMade,
   nint                 currentCallCount,
   pNWDPNSrvObjListItem itemReceivedPtr
   );

/* Global Variable Declarations */

/* Function Prototype Declarations */
 N_EXTERN_LIBRARY(nint)
NWDPNSrvAddBrokerObject(
   NWDPAccessorRef accessorRef,
   pnstr16 objectRDN16Ptr,
   /*
   // The next two parameters may be NULL if
   // NWDP_NSRV_FLG_ENABLE_RESMAN_SVC not present in 
   // 'flags' parameter. 
   */
   pnstr16 resourceMgrVolObjectRDN16Ptr,
   pnstr16 resourceMgrDatabasePath16Ptr,
   pNWDPNSrvObjRef nsObjRefPtr,
   nuint32 flags
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvAddPrinterObject(
   NWDPAccessorRef accessorRef,
   pnstr16 objectRDN16Ptr,
   pNWDPNSrvObjRef nsObjRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvAddPSMObject(
   NWDPAccessorRef accessorRef,
   pnstr16 objectRDN16Ptr,
   pnstr16 databaseVolObjectRDN16Ptr,
   pNWDPNSrvObjRef nsObjRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvCompareNDSObjectNames(
   NWDPAccessorRef   accessorRef,
   pnstr16           treeName16Ptr, /* may be NULL */
   pnstr16           object1Name16Ptr,
   pnstr16           object2Name16Ptr
   );
   
 N_EXTERN_LIBRARY(nint)
NWDPNSrvCreateRef(
   NWDPAccessorRef accessorRef,
   pnstr16 objectRDN16Ptr,
   NWDPNSrvObjType objectType,
   pNWDPNSrvObjRef nsObjRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvDestroyRef(
   NWDPAccessorRef accessorRef,
   pNWDPNSrvObjRef nsObjRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvGetNativeNDSContext(
   NWDPAccessorRef accessorRef,
   pnuint32        contextHandlePtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvListObjects(
   NWDPAccessorRef   accessorRef,
   NWDPNSrvObjType   objectTypeFilter,
   NWDPNSrvObjListCallback listCallback,
   nparam            callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvMakeFQNFromObject(
   NWDPAccessorRef      accessorRef,
   pnstr16              objectRDN16Ptr,
   nuint                sizeOfBuffer,
   pNWDPNSrvFQNBuffer   fqnBufferPtr,
   pnuint               sizeOfResultPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvModifyAttrs(
   NWDPAccessorRef accessorRef,
   NWDPNSrvObjRef nsObjRef,
   NWDPAttrSetRef modifyRef,
   NWDPModifyOperatorEnum nsrvOperator
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvModifyNDSSchema(
   NWDPAccessorRef accessorRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvObjGetAttributeSet(
   NWDPAccessorRef   accessorRef,
   NWDPNSrvObjRef    nsObjRef,
   NWDPOidSetRef     requestedOidSetRef,
   pNWDPAttrSetRef   resultAttrSetRefPtr,
   pNWDPASAVPRef     resultAvpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvQueryRoleMembership(
   NWDPAccessorRef   accessorRef,
   NWDPNSrvObjRef    nsObjRef,
   pnstr16           memberRDN16Ptr,
   pnbool            isAManager,
   pnbool            isAnOperator,
   pnbool            isAUser
   );

   /* new for 1.1 */   
 N_EXTERN_LIBRARY(nint)
NWDPNSrvQueryRoleMembership2(
   NWDPAccessorRef   accessorRef,
   NWDPNSrvObjRef    nsObjRef,
   pnstr16           memberRDN16Ptr,
   NWDPNSrvRoleFlag  requestedRoleFlags,
   pNWDPNSrvRoleFlag resultRoleFlagsPtr
   );
   
 N_EXTERN_LIBRARY(nint)
NWDPNSrvRemoveObject(
   NWDPAccessorRef accessorRef,
   pNWDPNSrvObjRef nsObjRefPtr,
   /*
   // The flag: NWDP_NSRV_FLG_DONT_DEL_OBJECT is intended to cause 
   // only the cleanup of object creation side effects. Actual object
   // deletion in the Name Service is left to the caller. The object must
   // still exist when this call is made.
   */
   nuint32         flags
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvSetNativeNDSContext(
   NWDPAccessorRef accessorRef,
   nuint32 contextHandle
   );

 N_EXTERN_LIBRARY(nint)
NWDPNSrvValidateObjectRef(
	NWDPAccessorRef accessorRef,
   NWDPNSrvObjRef objectRef
   );

#else /* NWDP_NSR_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_nsr.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_NSR_H */

