/*
//ͻ
// (c) 1995-1998 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_SOK.H                                           
//͹
// Library VeRsIoN=1.1.0                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_SOK_H )
   #define NWDP_SOK_H

/* Standard Library Header Includes */
   #if !defined(NTYPES_H)
      #include <ntypes.h>
   #endif

/* Manifest Constant Definitions */

   /*
   // ===========================================
   // R A W   V A L U E S   D O   N O T   U S E !
   // ===========================================
   */

      /*
      // Well-known IPx/SPX Sockets
      */

      #define NWDP_PSM_AND_PA_SOCKET      0x90B2

      #define NWDP_BROKER_SRVC_SOCKET     0x90B3

      #define NWDP_SRVC_REGISTRY_SOCKET   0x90B4

      #define NWDP_EVENT_NOTIFY_SOCKET    0x90B5

      #define NWDP_RESOURCE_MGMT_SOCKET   0x90B6

      #define NWDP_NOTIFY_LISTENR_SOCKET  0x90B7

      /*
      // Well-known IP Ports
      */

      #define NWDP_BROKER_SRVC_PORT       3014

      #define NWDP_EVENT_NOTIFY_PORT      3016

      #define NWDP_NOTIFY_LISTENR_PORT    3017

      #define NWDP_SRVC_REGISTRY_PORT     3018

      #define NWDP_RESOURCE_MGMT_PORT     3019

      #define NWDP_PSM_AND_PA_PORT        3396



   /*
   // =======================================
   // V A L U E S   I N   H I L O   O R D E R 
   // =======================================
   */

      /*
      // Well-known IPX/SPX Sockets (HiLo order)
      */
      #define NWDP_PSM_AND_PA_SOCKET_HILO    \
               NSwapHiLo16(NWDP_PSM_AND_PA_SOCKET)

      #define NWDP_BROKER_SRVC_SOCKET_HILO   \
               NSwapHiLo16(NWDP_BROKER_SRVC_SOCKET)

      #define NWDP_SRVC_REGISTRY_SOCKET_HILO \
               NSwapHiLo16(NWDP_SRVC_REGISTRY_SOCKET)

      #define NWDP_EVENT_NOTIFY_SOCKET_HILO  \
               NSwapHiLo16(NWDP_EVENT_NOTIFY_SOCKET)

      #define NWDP_RESOURCE_MGMT_SOCKET_HILO \
               NSwapHiLo16(NWDP_RESOURCE_MGMT_SOCKET)

      #define NWDP_NOTIFY_LISTENR_SOCKET_HILO \
               NSwapHiLo16(NWDP_NOTIFY_LISTENR_SOCKET)

      /*
      // Well-known IP Ports
      */
      #define NWDP_PSM_AND_PA_PORT_HILO    \
               NSwapHiLo16(NWDP_PSM_AND_PA_PORT)

      #define NWDP_BROKER_SRVC_PORT_HILO   \
               NSwapHiLo16(NWDP_BROKER_SRVC_PORT)

      #define NWDP_SRVC_REGISTRY_PORT_HILO \
               NSwapHiLo16(NWDP_SRVC_REGISTRY_PORT)

      #define NWDP_EVENT_NOTIFY_PORT_HILO  \
               NSwapHiLo16(NWDP_EVENT_NOTIFY_PORT)

      #define NWDP_RESOURCE_MGMT_PORT_HILO \
               NSwapHiLo16(NWDP_RESOURCE_MGMT_PORT)

      #define NWDP_NOTIFY_LISTENR_PORT_HILO \
               NSwapHiLo16(NWDP_NOTIFY_LISTENR_PORT)

   /*
   // =======================================
   // V A L U E S   I N   L O H I   O R D E R 
   // =======================================
   */

      /*
      // Well-known IPX/SPX Sockets
      */
      #define NWDP_PSM_AND_PA_SOCKET_LOHI     \
               NSwapLoHi16(NWDP_PSM_AND_PA_SOCKET)

      #define NWDP_BROKER_SRVC_SOCKET_LOHI    \
               NSwapLoHi16(NWDP_BROKER_SRVC_SOCKET)

      #define NWDP_SRVC_REGISTRY_SOCKET_LOHI  \
               NSwapLoHi16(NWDP_SRVC_REGISTRY_SOCKET)

      #define NWDP_EVENT_NOTIFY_SOCKET_LOHI   \
               NSwapLoHi16(NWDP_EVENT_NOTIFY_SOCKET)

      #define NWDP_RESOURCE_MGMT_SOCKET_LOHI  \
               NSwapLoHi16(NWDP_RESOURCE_MGMT_SOCKET)

      #define NWDP_NOTIFY_LISTENR_SOCKET_LOHI \
               NSwapLoHi16(NWDP_NOTIFY_LISTENR_SOCKET)

      /*
      // Well-known IP Ports
      */
      #define NWDP_PSM_AND_PA_PORT_LOHI    \
               NSwapLoHi16(NWDP_PSM_AND_PA_PORT)

      #define NWDP_BROKER_SRVC_PORT_LOHI   \
               NSwapLoHi16(NWDP_BROKER_SRVC_PORT)

      #define NWDP_SRVC_REGISTRY_PORT_LOHI \
               NSwapLoHi16(NWDP_SRVC_REGISTRY_PORT)

      #define NWDP_EVENT_NOTIFY_PORT_LOHI  \
               NSwapLoHi16(NWDP_EVENT_NOTIFY_PORT)

      #define NWDP_RESOURCE_MGMT_PORT_LOHI \
               NSwapLoHi16(NWDP_RESOURCE_MGMT_PORT) 

      #define NWDP_NOTIFY_LISTENR_PORT_LOHI \
               NSwapLoHi16(NWDP_NOTIFY_LISTENR_PORT)

#else /* NWDP_SOK_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_sok.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_SOK_H */

