/*
//ͻ
// (c) 1995-1998 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_SRS.H                                           
//͹
// Library VeRsIoN=1.1.0                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_SRS_H )
   #define NWDP_SRS_H

/* Standard Library Header Includes */
   #if !defined(NWDP_LIB_H)
      #include <nwdp_lib.h>
   #endif

/* Header Includes */

/* Manifest Constant Definitions */

   #if !defined(OT_ADVERTISING_NDPS_SVC_REGSTRY)
      #if defined(_CLIENT32_)
         /* Client32 values are Lo-Hi ordered */
         #define OT_ADVERTISING_NDPS_SVC_REGSTRY   0x0282
      #else
         /* traditional values are Hi-Lo ordered */
         #define OT_ADVERTISING_NDPS_SVC_REGSTRY   0x8202
      #endif
   #endif

   /*
   // length definition sizes
   */
   #define NWDP_SRS_MAX_NAME_SIZE            64
   #define NWDP_SRS_MAX_ADDRESS_LEN         128
   #define NWDP_SRS_MAX_INFO_SIZE           128

/* Macro Definitions */

/* Type Definitions */
#define N_PACK_1
#include <npackon.h>


   /*
   // server type enum
   */
   typedef enum 
   {
      NWDP_SRS_SERVERTYPE_ALL=0,
      NWDP_SRS_SERVERTYPE_PA =1,
      NWDP_SRS_SERVERTYPE_NTS=2,
      NWDP_SRS_SERVERTYPE_RMS=3,
      NWDP_SRS_SERVERTYPE_NPH=4
   } NWDPSrsServerType, N_FAR *pNWDPSrsServerType;

   /*
   // info item definition
   */
   typedef enum
   {
      NWDP_INFO_ITEM_INT8,
      NWDP_INFO_ITEM_INT16,
      NWDP_INFO_ITEM_INT32,
      NWDP_INFO_ITEM_BOOL,
      NWDP_INFO_ITEM_STRING,
      NWDP_INFO_ITEM_OCTET_STR
   } NWDPInfoItemEnum, N_FAR *pNWDPInfoItemEnum;

   typedef struct
   {
      NWDPInfoItemEnum     designator;
      union
      {
         nuint8            uInt8;
         nuint16           uInt16;
         nuint32           uInt32;
         nbool             flag;
         pnstr             nString;   
         NWDPOctetString   octetString;
      } u;
   } NWDPInfoItem, N_FAR *pNWDPInfoItem;

   /*
   // server list callback item structures
   */
   typedef struct
   {
      NWDPText          serverName;
      NWDPSrsServerType serverType;
      NWDPNetAddress    address;
      nuint             infoCount;
      pNWDPInfoItem     infoPtr;
   } NWDPServerListItem, N_FAR *pNWDPServerListItem;

   typedef struct
   {
      NWDPText          serverName;
      NWDPSrsServerType serverType;
      nuint             addressCount;
      pNWDPNetAddress   addressPtr;
      nuint             infoCount;
      pNWDPInfoItem     infoPtr;
   } NWDPServerListItem2, N_FAR *pNWDPServerListItem2;


#include <npackoff.h>

/* Callback Definitions */
 N_TYPEDEF_CALLBACK(nint,
NWDPSrsServersListCallback)(
   NWDPAccessorRef      accessorRef,
   nparam               callerDefinedParam,
   nint                 totalCallsToBeMade,
   nint                 currentCallCount,
   pNWDPServerListItem  itemReceivedPtr
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPSrsServersListCallback2)(
   NWDPAccessorRef      accessorRef,
   nparam               callerDefinedParam,
   nint                 totalCallsToBeMade,
   nint                 currentCallCount,
   pNWDPServerListItem2 itemReceivedPtr
   );

/* Global Variable Declarations */

/* Function Prototype Declarations */

 N_EXTERN_LIBRARY(nint)
NWDPSrsCreateRefBasedOnAddr(
   NWDPAccessorRef   accessorRef,
   pNWDPNetAddress   netAddrPtr,
   pNWDPSrsRef       srsRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPSrsCreateRefBasedOnFQN(
   NWDPAccessorRef      accessorRef,
   pNWDPNSrvFQN         brokerFqnPtr,
   pNWDPSrsRef          srsRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPSrsCreateRefBasedOnSAP(
   NWDPAccessorRef   accessorRef,
   pNWDPSrsRef       srsRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPSrsDeregisterServer(
   NWDPAccessorRef   accessorRef,
   NWDPSrsRef        serviceRef,
   NWDPSrsServerType serverType,
   pNWDPText         serverNamePtr,
   pNWDPNetAddress   addressPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPSrsDestroyRef(
   NWDPAccessorRef   accessorRef,
   pNWDPSrsRef       srsRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPSrsGetConnectionStatus(
   NWDPAccessorRef accessorRef,
   NWDPSrsRef      srsRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPSrsGetFQN(
   NWDPAccessorRef      accessorRef,
   NWDPSrsRef           serviceRef,
   nuint                sizeOfBuffer,
   pNWDPNSrvFQNBuffer   fqnBufferPtr,
   pnuint               sizeOfResultPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPSrsListServers(
   NWDPAccessorRef   accessorRef,
   NWDPSrsRef        srsRef,
   NWDPSrsServerType serverType,
   NWDPSrsServersListCallback listCallback,
   nparam            callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPSrsListServers2(
   NWDPAccessorRef   accessorRef,
   NWDPSrsRef        srsRef,
   NWDPSrsServerType serverType,
   NWDPSrsServersListCallback2 listCallback,
   nparam            callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPSrsRegisterServer(
   NWDPAccessorRef   accessorRef,
   NWDPSrsRef        serviceRef,
   NWDPSrsServerType serverType,
   pNWDPText         serverNamePtr,
   pNWDPNetAddress   addressPtr,
   nuint             infoCount,
   pNWDPInfoItem     infoPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPSrsValidateRef(
   NWDPAccessorRef   accessorRef,
	NWDPSrsRef        srsRef
   );

#else /* NWDP_SRS_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_srs.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_SRS_H */
