/*
$----------------------------------------------------------------------------$
   $Workfile:   nwsnapin.h  $
   $Revision:   1.33  $
    $Modtime:   01 Apr 1996 15:57:42  $
$----------------------------------------------------------------------------$
   Copyright (c) 1989-1996 Novell, Inc.  All Rights Reserved.

   THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
   TREATIES. NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED
   COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
   EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED
   WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
   OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
   CRIMINAL AND CIVIL LIABILITY.$
$----------------------------------------------------------------------------$
*/

#ifndef NWSNAPIN_H
#define NWSNAPIN_H

#include <ntypes.h>
#include <nwdsdefs.h>

#ifdef __cplusplus
extern "C"
{
#endif

/*-----------------------------------------------------*/
/* Snapin macros for WIN 3.1 and WIN32 Snapin          */
/*-----------------------------------------------------*/
#ifdef WIN32 
 #define NWA_SNAPIN_CALLBACK N_EXTERN_CALLBACK
 #define NWA_SNAPIN_FLAGS    pnuint
 #define NWA_SCROLL_DLL      "muscrl32.dll"
#else
 #define NWA_SNAPIN_CALLBACK N_EXTERN_LIBRARY
 #define NWA_SNAPIN_FLAGS    pnuint
 #define NWA_SCROLL_DLL      "muscroll.dll"
#endif



N_TYPEDEF_CALLBACK (NWRCODE, NWASnapinObjectProc)
(
   pnstr8 objName,
   nuint16 message,
   nparam param1,
   nparam param2
);

N_TYPEDEF_CALLBACK (void, NWASnapinMenuActionProc)
(void);

N_TYPEDEF_CALLBACK (void, NWASnapinMenuValidProc)
(pnuint);

N_TYPEDEF_CALLBACK (nuint32, NWAFlatBrowserProc)
(
   nuint32 userParam,
   nuint16 uMsg,
   nparam param1,
   nparam param2
);

N_TYPEDEF_CALLBACK (nuint32, NWAMVEDProc)
(
   nuint32 userParam,
   nuint16 uMsg,
   nparam param1,
   nparam param2
);

N_TYPEDEF_CALLBACK( void, NWASnapinTBButtonEnableProc )
(
  nint   menuID,
  pnbool pfEnabled
);

/*--------------------------------------------------------------------*/
/* Snapin MDI Child Callback and MDI Child Window Callback fn typedef */
/*--------------------------------------------------------------------*/
N_TYPEDEF_CALLBACK ( LRESULT, NWASnapinMDIChildProc )
(
   pnstr8    viewName,
   nuint16   message,
   nparam    param1,
   nparam    param2
);


/*------------------------------------------------------------*/
/* SNAPIN Version related defines                             */
/*------------------------------------------------------------*/
#define    NWA_SNAPIN_VER_MAJOR     1
#define    NWA_SNAPIN_VER_MINOR     1
#define    NWA_SNAPIN_VER_REVISION  0
#define    NWA_SNAPIN_VERSION       NMake32( NMake16(NWA_SNAPIN_VER_REVISION, 0 )  , NMake16(NWA_SNAPIN_VER_MINOR, NWA_SNAPIN_VER_MAJOR ) )

/*------------------------------------------------------------*/
/* View Names                                                 */
/*------------------------------------------------------------*/
#define    NWA_VIEW_CONSOLE        "ListMenu"
#define    NWA_VIEW_BROWSER        "BROWSER"

/*--------------------------------------------*/
/*   messages from nwadmin to object snapins  */
/*--------------------------------------------*/
#define    NWA_MSG_INITSNAPIN              0x0100
#define    NWA_MSG_CLOSESNAPIN             0x0101
#define    NWA_MSG_CREATEOBJECT            0x0102
#define    NWA_MSG_GETPAGECOUNT            0x0103
#define    NWA_MSG_REGISTERPAGE            0x0104
#define    NWA_MSG_RENAME                  0x0105
#define    NWA_MSG_MODIFY                  0x0106
#define    NWA_MSG_QUERYDELETE             0x0107
#define    NWA_MSG_QUERYCOPY               0x0108
#define    NWA_MSG_QUERYMOVE               0x0109
#define    NWA_MSG_GETVALIDOPERATIONS      0x0110
#define    NWA_MSG_MPEWCLOSE               0x0111
#define    NWA_MSG_NOTIFYDELETE            0x0112
#define    NWA_MSG_NOTIFYMOVE              0x0113
#define    NWA_MSG_NOTIFYRENAME            0x0114
#define    NWA_MSG_NOTIFYCREATEOBJECT      0x0115


/*-------------------------------------------------------------------*/
/* Mpew Messages to support Object Create Template, Generic attr     */
/* details, Multiple Object Details                                  */
/*-------------------------------------------------------------------*/
#define    NWA_MSG_QUERYAPPLYTEMPLATE      0x0116
#define    NWA_MSG_APPLYTEMPLATE           0x0117
#define    NWA_MSG_MULTIOBJ_COUNT          0x0118
#define    NWA_MSG_MULTIOBJ_NAME           0x0119
#define    NWA_MSG_GENATTR_GETCOUNT        0x011A
#define    NWA_MSG_GENATTR_GETATTR         0x011B

/*------------------------------------------------------------------------*/
/* Snapin Messages to MDI Child Proc to Clear, Save, and Restore Settings */
/*------------------------------------------------------------------------*/

#define    NWA_MSG_MDICHILD_CREATED        0x011C
#define    NWA_MSG_MDICHILD_CLEARSETTINGS  0x011D
#define    NWA_MSG_MDICHILD_SAVESETTINGS   0x011E
#define    NWA_MSG_MDICHILD_RESTORE        0x011F


#define    NWA_MSG_SNAPINMDICHILD_NOTIFY   WM_USER + 0x160



/*----------------------------------------------*/
/*    message from snapin page to its parent    */
/*----------------------------------------------*/
#define    NWA_WM_SETPAGEMODIFY     WM_USER+0x120

#define    NWA_WM_CANCLOSE          WM_USER+0x121

/*--------------------------------------------------------------*/
/* F1 help message to all snapin dialogs                        */
/* MPEW also sends the same message when Help button is pressed */
/*--------------------------------------------------------------*/
#define  NWA_WM_F1HELP              (WM_USER + 0x139)

#define  NWA_MENU_BASE               0x1000

/*--------------------------------------------------------------*/
/* Messages passed to Flat Browser Proc                         */
/*--------------------------------------------------------------*/
#define  NWA_MSG_FBOBJECT_COUNT  0x0200
#define  NWA_MSG_FBOBJECT_VALUE  0x0201
#define  NWA_MSG_FBFILTER_COUNT  0x0202
#define  NWA_MSG_FBFILTER_VALUE  0x0203
#define  NWA_MSG_FBSET_HELP      0x0204
#define  NWA_MSG_FBSET_CAPTION   0x0205

/*----------------------------------------------*/
/* General message from snapin view to parent   */
/*----------------------------------------------*/
#define NWA_MSG_IVEGOTFOCUS               (WM_USER + 0x140)  

/*----------------------------------------------*/
/* Status Bar messages - snapin view to parent  */
/*----------------------------------------------*/
#define NWA_MSG_STATUSBAR_ADDITEM          (WM_USER + 0x141)  
#define NWA_MSG_STATUSBAR_SETITEMTEXT      (WM_USER + 0x142)  

/*----------------------------------------------*/
/* Status Bar messages - parent to snapin view  */
/*----------------------------------------------*/
#define NWA_MSG_STATUSBAR_ADDPREFITEM      (WM_USER + 0x143)
#define NWA_MSG_STATUSBAR_NEWACTIVEITEMS   (WM_USER + 0x144)
#define NWA_MSG_STATUSBAR_POPULATE         (WM_USER + 0x145)  
#define NWA_MSG_STATUSBAR_QUERYITEMCOUNT   (WM_USER + 0x146)
#define NWA_MSG_STATUSBAR_QUERYACTIVECOUNT (WM_USER + 0x147)
#define NWA_MSG_STATUSBAR_QUERYACTIVEITEMS (WM_USER + 0x148)
#define NWA_MSG_STATUSBAR_DBLCLK           (WM_USER + 0x149)  
       
/*----------------------------------------------*/
/* ToolBar messages - snapin view to parent     */
/*----------------------------------------------*/
#define NWA_MSG_TOOLBAR_ADDITEM            (WM_USER + 0x14A)  
#define NWA_MSG_TOOLBAR_GETBUTTONSTATE     (WM_USER + 0x14B)  
#define NWA_MSG_TOOLBAR_GETBUTTONTYPE      (WM_USER + 0x14C)  
#define NWA_MSG_TOOLBAR_SETBUTTONSTATE     (WM_USER + 0x14D)

/*----------------------------------------------*/
/* ToolBar messages - parent to snapin view     */
/*----------------------------------------------*/
#define NWA_MSG_TOOLBAR_ADDPREFITEM        (WM_USER + 0x14E)  
#define NWA_MSG_TOOLBAR_NEWACTIVEITEMS     (WM_USER + 0x14F)
#define NWA_MSG_TOOLBAR_POPULATE           (WM_USER + 0x150)
#define NWA_MSG_TOOLBAR_QUERYENABLEBUTTON  (WM_USER + 0x151)
#define NWA_MSG_TOOLBAR_QUERYACTIVECOUNT   (WM_USER + 0x152)
#define NWA_MSG_TOOLBAR_QUERYACTIVEITEMS   (WM_USER + 0x153)
#define NWA_MSG_TOOLBAR_QUERYITEMCOUNT     (WM_USER + 0x154)

/*----------------------------------------------------------------*/
/* Flags or-ed to specify options for Flat Browser                */
/*----------------------------------------------------------------*/
#define NWA_FB_BROWSE_PUBLIC     0x00000001L
#define NWA_FB_BROWSE_ROOT       0x00000002L
#define NWA_FB_SINGLE_SELECT     0x00000004L
#define NWA_FB_MULTIPLE_SELECT   0x00000008L
#define NWA_FB_NONDS_VOLUMES     0x00000010L
#define NWA_FB_EXPAND_VOLUMES    0x00000020L


/*----------------------------------------------------------------*/
/* edit Types for MVED Control                                    */
/*----------------------------------------------------------------*/
#define NWA_MVED_VALUE_STRING      0x0000
#define NWA_MVED_VALUE_READONLY    0x0001
#define NWA_MVED_VALUE_DISTNAME    0x0002
#define NWA_MVED_VALUE_DIGITSONLY  0x0004
#define NWA_MVED_VALUE_PRINTABLE   0x0005

/*----------------------------------------------------------------*/
/* Message passed to MVED callback proc                           */
/*----------------------------------------------------------------*/
#define NWA_MSG_MVED_INITCOUNT   0x300
#define NWA_MSG_MVED_INITVALUE   0x301




/*----------------------------------------------------------*/
/* return values from snapins to admin and admin to snapin  */
/*----------------------------------------------------------*/
#define    NWA_RET_SUCCESS                     0
#define    NWA_RET_DODEFAULT                   1
#define    NWA_RET_SHOWDETAILS                 2
#define    NWA_RET_CREATEANOTHER               3
#define    NWA_RET_USETEMPLATE                 4 
#define    NWA_RET_USENOTEMPLATE               5 


#define    NWA_ERR_ERROR                                               -1
#define    NWA_ERR_NO_MEMORY                                         -901
#define    NWA_ERR_DUPLICATE_ENTRY                                   -902
#define    NWA_ERR_UNKNOWN_ERROR                                     -903
#define    NWA_ERR_INVALID_STRING_PARAMETER                          -904
#define    NWA_ERR_INVALID_BITMAP_PARAMETER                          -905
#define    NWA_ERR_INVALID_BITMAP_POINTER_PARAMETER                  -906
#define    NWA_ERR_INSUFFICIENT_STRING_BUFFER                        -907
#define    NWA_ERR_CLASSNAME_TABLE_NOT_INITIALIZED                   -908
#define    NWA_ERR_ATTRNAME_TABLE_NOT_INITIALIZED                    -909
#define    NWA_ERR_BITMAP_TABLE_NOT_INITIALIZED                      -910
#define    NWA_ERR_ALIAS_BITMAP_TABLE_NOT_INITIALIZED                -911
#define    NWA_ERR_CLASSNAME_NOT_FOUND                               -912
#define    NWA_ERR_ATTRNAME_NOT_FOUND                                -913
#define    NWA_ERR_BITMAP_NOT_FOUND                                  -914
#define    NWA_ERR_IS_BAD_STRING_POINTER                             -915
#define    NWA_ERR_INVALID_PARAMETER                                 -916
#define    NWA_ERR_LAUNCH_FBROWSER                                   -917
#define    NWA_ERR_FUNCTION_FAILED                                   -918
#define    NWA_ERR_INVALID_CALLBACK_PROC                             -919
#define    NWA_ERR_INVALID_MODULE_HANDLE                             -920
#define    NWA_ERR_INVALID_SNAPIN_VERSION                            -921
#define    NWA_ERR_DUPLICATE_TOOLBAR_BUTTON_NAME                     -922
#define    NWA_ERR_INVALID_MENUID                                    -923
#define    NWA_ERR_INVALID_INSTANCE_HANDLE                           -924
#define    NWA_ERR_INVALID_STRING_RESOURCE_ID                        -925
#define    NWA_ERR_INVALID_STRUCT_SIZE                               -926
#define    NWA_ERR_INVALID_CLASSNAME                                 -927
#define    NWA_ERR_INVALID_SNAPINFLAG                                -928
#define    NWA_ERR_MAX_MDICHILDWINDOWS_EXCEEDED                      -929
#define    NWA_ERR_INVALID_CLASSTYPE                                 -930
#define    NWA_ERR_FILE_NOT_FOUND                                    -931
#define    NWA_ERR_ITEM_NOT_FOUND                                    -932
#define    NWA_ERR_BROWSER_NOT_ACTIVE                                -933

/*------------------------------------------------------------*/
/* snapins should '|' operations they support and             */
/* return in response to NWAD_GETVALIDOPERATIONS              */
/*------------------------------------------------------------*/
#define NWA_OP_DSTYPE          0x00000001L
#define NWA_OP_FSTYPE          0x00000002L
#define NWA_OP_CREATE          0x00000004L
#define NWA_OP_DETAILS         0x00000008L
#define NWA_OP_MOVE            0x00000010L
#define NWA_OP_COPY            0x00000020L
#define NWA_OP_RENAME          0x00000040L
#define NWA_OP_DELETE          0x00000080L
#define NWA_OP_USERTEMPLATE    0x00000100L
#define NWA_OP_SEARCH          0x00000200L
#define NWA_OP_CONTAINER       0x00000400L

typedef struct tagNWAPageStruct
{
   DLGPROC dlgProc;  /* dialog procedure */
   HINSTANCE hDLL;   /* resource DLL handle */
   LPSTR resName;    /* resource name */
   LPSTR pageTitle;  /* title of the page in the listbox */
   LPARAM initParam; /* initialization parameters */
}  NWAPageStruct;

#define NWA_MAX_TRANSLATED_NAME  256
#define NWA_MAX_CLASS_NAME       MAX_SCHEMA_NAME_BYTES
#define NWA_MAX_CLASS_TYPE       MAX_SCHEMA_NAME_BYTES
#define NWA_MAX_OBJECT_NAME      MAX_DN_BYTES
#define NWA_DS_OBJECT_TYPE       "DS"
#define NWA_FS_OBJECT_TYPE       "FS"
#define NWA_MAX_PATH_SIZE        324   /* server+volume+dirPath = 324 */


/*--------------------------------------------------------------------*/
/* Snapin MDI Child class name max length and dev info max len        */
/*--------------------------------------------------------------------*/

#define NWA_MAX_CLASSNAMELENGTH   32
#define NWA_MAX_DEVINFOLENGTH     128


typedef struct tagNWASelObject
{
   char objType[NWA_MAX_CLASS_TYPE];   /* "DS", "FS" or some user defined */
   char objClass[NWA_MAX_CLASS_NAME];  /* object class name */
   char objName[NWA_MAX_OBJECT_NAME];  /* complete name or path */
}  NWASelObject, N_FAR * PNWASelObject;

/*----------------------------------------------------------------------*/
/* Definitions and structures for snapin toolbar and status bar support */
/*----------------------------------------------------------------------*/
#define TBID_SEPARATOR   -3 /* used as identifier for a separator */
   
typedef enum {
   TBUp,
   TBDown,
   TBIndeterminate
} TBState;      

typedef enum {
   TBCommand,
   TBToggle,
   TBUnknown
} TBType;  
                                               
typedef struct {
   nuint32     lStructSize;
   HINSTANCE   hResourceDLL;
   nint        menuId;
   nint        hintId;
   nint        bitmapId;
   nint        toolTipStrId;
   TBState     buttonState;
   TBType      buttonType;
   nbool       fEnabled;
} NWAToolBarItemStruct;

typedef struct {
   nuint32     lStructSize;
   nint        menuId;
   HINSTANCE   hResourceDLL;
   nint        itemStrId;
   nint        hintStrId;
   nint        bitmapId;
} NWAToolBarPrefItemStruct;
                                                       
typedef struct {
   nuint32     lStructSize;
   nint        itemId;
   nuint       maxChars;
   pnstr8      pszText;
} NWAStatusBarItemStruct;


typedef struct {
   nuint32     lStructSize;
   nint        itemId;
   HINSTANCE   hResourceDLL;
   nint        textResId;
   nint        hintResId;
   nuint       maxChars;
} NWAStatusBarPrefItemStruct;

#define TBSNAPINVIEW   "ToolBarSnapinView"



#define NWA_MAX_MENUITEMNAME_LEN 64
#define NWA_MAX_MENUITEMHINT_LEN 128

/*-------------------------------------------------------------------*/
/* Snapin Tools menu item struct                                     */
/*-------------------------------------------------------------------*/
typedef struct tagNWAToolsMenuItem
{
   nuint32      structSize;
   nuint        parentMenuId;
   nuint        menuId;
   nuint        menuOption;
   char         szMenuText[NWA_MAX_MENUITEMNAME_LEN];
   char         szMenuHintText[NWA_MAX_MENUITEMHINT_LEN];
}  NWAToolsMenuItem ;

/*-------------------------------------------------------------------*/
/* Create MDI Child param structure                                  */
/*-------------------------------------------------------------------*/
typedef struct tagNWACreateMDIChildParam
{
  nuint32           structSize;
  WINDOWPLACEMENT   wndpl;
} NWACreateMDIChildParam ;


/* prototypes */

int   FAR PASCAL InitSnapin (void);
void  FAR PASCAL PostInitSnapin(HWND hwndAdmin);
void  FAR PASCAL ShutDown (void);
nbool FAR PASCAL CanCloseSnapin( void );

N_EXTERN_LIBRARY (NWRCODE)
NWAGetSelObjectCount
(
   pnint32 lpCount
);

N_EXTERN_LIBRARY (NWRCODE)
NWAGetSelObject
(
   nint32 index,
   PNWASelObject selObject
);

N_EXTERN_LIBRARY (NWRCODE)
NWARegisterObjectProc
(
   pnstr8 classType,
   pnstr8 className,
   pnstr8 developerInfo,
   HINSTANCE hDLL,
   NWASnapinObjectProc proc,
   nuint32 version
);

N_EXTERN_LIBRARY (NWRCODE)
NWARegisterMenu
(
   pnstr8 viewName,
   nuint16 menuParentId,
   pnstr8 menuParent,
   nuint16 menuOption,
   pnuint pmenuID,
   pnstr8 menuString,
   pnstr8 menuHint,
   NWASnapinMenuActionProc menuActionProc,
   NWASnapinMenuValidProc menuValidProc,
   nuint32 version
);

/*------------------------------------------------------------------*/
/*             translation and bitmap table functions               */
/*------------------------------------------------------------------*/
N_EXTERN_LIBRARY (NWRCODE)
NWAAddClassData
(
   LPCSTR pszClassName,
   LPCSTR pszTranslation,
   HBITMAP hClassBitmap,
   HBITMAP hClassAliasBitmap,
   HBITMAP hClassROBitmap
);

N_EXTERN_LIBRARY (NWRCODE)
NWARemoveClassData
(
   LPCSTR pszClassName,
   HBITMAP * phClassBitmap,
   HBITMAP * phClassAliasBitmap,
   HBITMAP * phClassROBitmap
);

N_EXTERN_LIBRARY (NWRCODE)
NWAGetTranslatedClassName
(
   LPCSTR pszClassName,
   pnstr8 pszTranslation,
   nint16 nMaxLen
);

N_EXTERN_LIBRARY (NWRCODE)
NWAGetClassBitmap
(
   LPCSTR pszClassName,
   HBITMAP * phBitmap
);

N_EXTERN_LIBRARY (NWRCODE)
NWAGetClassAliasBitmap
(
   LPCSTR pszClassName,
   HBITMAP * phBitmap
);

N_EXTERN_LIBRARY (NWRCODE)
NWAGetClassReadOnlyBitmap
(
   LPCSTR pszClassName,
   HBITMAP * phBitmap
);

N_EXTERN_LIBRARY (NWRCODE)
NWAAddPropertyNameTranslation
(
   LPCSTR pszPropertyName,
   LPCSTR pszClassName,
   LPCSTR pszTranslation
);

N_EXTERN_LIBRARY (NWRCODE)
NWAGetTranslatedPropertyName
(
   LPCSTR pszPropertyName,
   LPCSTR pszClassName,
   pnstr8 pszTranslation,
   nint16 nMaxLen
);

N_EXTERN_LIBRARY (NWRCODE)
NWARemovePropertyNameTranslation
(
   LPCSTR pszPropertyName,
   LPCSTR pszClassName
);

/*------------------------------------------------------------------*/
/*         Launch DS and FS flat browser functions                  */
/*------------------------------------------------------------------*/
/*  Every call to NWACommonStartUp must be matched by a similar     */
/*  call to NWACommonShutDown.  These functions need only be called */
/*  in 16-bit snapins and only if NWALaunchDSFlatBrowser is being   */
/*  called outside of the NetWare Administrator.  In this event     */
/*  only the NWCOMNxx.DLL is required to run.                       */
/*------------------------------------------------------------------*/
   
N_EXTERN_LIBRARY (void) NWACommonStartUp (); 
N_EXTERN_LIBRARY (void) NWACommonShutDown ();


N_EXTERN_LIBRARY (NWRCODE)
NWALaunchDSFlatBrowser
(
   HWND                 hwndParent,
   nuint32              userParam,
   LPSTR                contextStr,
   LPCSTR               selObjectStr,
   LPCSTR               navObjectStr,
   LPCSTR               selObjectLabel,
   nuint32              brwsFlags,
   NWAFlatBrowserProc   pfn
);

N_EXTERN_LIBRARY (NWRCODE)
NWALaunchFSFlatBrowser
(
   HWND hwndParent,
   nuint32 userParam,
   LPSTR dsContextStr,
   LPSTR fsContextStr,
   LPCSTR selObjectStr,
   LPCSTR navObjectStr,
   LPCSTR selObjectLabel,
   nuint32 brwsFlags,
   NWAFlatBrowserProc pfn
);

/*------------------------------------------------------------------*/
/*  Launch MVED functions                                           */
/*------------------------------------------------------------------*/
N_EXTERN_LIBRARY (NWRCODE)
NWACreateMved
(
   HWND hwndParent,
   nuint32 userParam,
   nuint16 idEdit,
   nuint16 idSpin,
   nuint16 idButton,
   nuint16 editType,
   nuint16 lengthEdit,
   LPCSTR label,
   LPCSTR contextStr,
   nuint32 brwsFlags,
   NWAMVEDProc pfn
);

N_EXTERN_LIBRARY (NWRCODE)
NWAGetMvedCount
(
   HWND hwndParent,
   nuint32 idEdit,
   pnuint16 pCount
);

N_EXTERN_LIBRARY (NWRCODE)
NWAGetMvedValue
(
   HWND hwndParent,
   nuint16 idEdit,
   nuint16 itemIndex,
   nuint16 bufSize,
   pnstr pValue
);

/*------------------------------------------------------------------*/
/*    NWAdmin and Snapin Interface Version Functions                */
/*------------------------------------------------------------------*/

N_EXTERN_LIBRARY (NWRCODE)
NWAGetNWAdminVersion
(
   pnuint32 pVersion
);

N_EXTERN_LIBRARY (HWND)
NWAGetConsoleWindowHandle
(
   void
);


/*------------------------------------------------------------------*/
/*    NWAdmin ToolBar Function                                      */
/*------------------------------------------------------------------*/
#define  NWA_MAX_SNAPIN_BUTTON_NAME    64

typedef struct 
{
   nuint32                          lStructSize;
   pnstr8                           nameOfSnapinButton;  // for ID purposes
   nint                             menuId;
   HINSTANCE                        hResourceDLL;
   nint                             bitmapId;
   nint                             textStrId;
   nint                             hintStrId;
   nint                             toolTipStrId;
   TBState                          buttonState;
   TBType                           buttonType;
   NWASnapinTBButtonEnableProc      enableProc;
   nuint32                          version;
} NWAToolBarRegistrationStruct;


N_EXTERN_LIBRARY (NWRCODE) 
NWARegisterToolBarButton
(
   NWAToolBarRegistrationStruct *   pStruct
);

N_EXTERN_LIBRARY (NWRCODE)
NWALaunchConfigDialog
(
   void
);

/*-------------------------------------------------------------------*/
/* Snapin MDI Child Register and Create Functions                    */     
/*-------------------------------------------------------------------*/

#define NWA_MAX_MDICHILDWINDOWS  12

N_EXTERN_LIBRARY ( NWRCODE )
NWARegisterMDIChildWindow
(
   LPCSTR                    className,
   LPCSTR                    developerInfo,
   HINSTANCE                 hDLL,
   NWASnapinMDIChildProc     classProc,
   HMENU                     hClassMenu,
   HICON                     hClassIcon,
   nuint32                   version
);


N_EXTERN_LIBRARY ( NWRCODE )
NWACreateMDIChildWindow
(
   LPCSTR                  className,
   LPCSTR                  windowTitle,
   HWND *                  pHwnd,
   NWACreateMDIChildParam* pcreateParam
);

/*---------------------------------------------------------------------*/
/* Tools menu item enumeration and invocation function                 */
/*---------------------------------------------------------------------*/
N_EXTERN_LIBRARY ( NWRCODE )
NWAGetToolsMenuItemCount
(
   pnstr8      viewName,
   pnuint16    pCount
);

N_EXTERN_LIBRARY ( NWRCODE )
NWAGetToolsMenuItem
(
   pnstr8            viewName,
   nuint16           itemIndex,
   NWAToolsMenuItem* pMenuItem
);

N_EXTERN_LIBRARY ( NWRCODE )
NWAProcessToolsMenuItemCommand
(
   pnstr8            viewName,
   NWAToolsMenuItem  menuItem
);

N_EXTERN_LIBRARY ( NWRCODE )
NWAProcessToolsMenuItemValid
(
   pnstr8            viewName,
   NWAToolsMenuItem  menuItem,
   pnuint            pFlags
);

/*---------------------------------------------------------------------*/
/* Function to query Save Settings menu option                         */
/*---------------------------------------------------------------------*/
N_EXTERN_LIBRARY ( NWRCODE )
NWAGetSaveSettingsOption
(
   BOOL*  pOptionFlag
);

/*----------------------------------------------------------------------*/
/* Extended Register Object Proc Function                               */
/*----------------------------------------------------------------------*/

// Snap-in flags to be used in NWARegisterObjectProcEx
//
#define NWA_SNAPIN_NORMAL              0x00000001
#define NWA_SNAPIN_TEMPLATE            0x00000002
#define NWA_SNAPIN_MULTIOBJ            0x00000003

// Snap-in must or this flag with others to have page setup
// option disabled.
//

#define NWA_SNAPIN_DISABLE_PAGESETUP   0x00010000



N_EXTERN_LIBRARY ( NWRCODE )
NWARegisterObjectProcEx
(
   pnstr8               classType,
   pnstr8               className,
   pnstr8               developInfo,
   HINSTANCE            hDLL,
   NWASnapinObjectProc  proc,
   nuint32              version,
   nuint32              snapinFlag
);

/*-----------------------------------------------------------------------*/
/* Get the Tree Name associated with Active Browser                      */
/*-----------------------------------------------------------------------*/
N_EXTERN_LIBRARY ( NWRCODE )
NWAGetTreeName
(
   pnstr   treeName,
   pnstr   defContext
);


/*-----------------------------------------------------------------------*/
/* Close NWAdmin application                                             */
/*-----------------------------------------------------------------------*/
N_EXTERN_LIBRARY ( NWRCODE )
NWAExitNWAdmin
(
   void 
);

/*-----------------------------------------------------------------------*/
/* Get NLS path name based on NWLanguage                                 */
/*-----------------------------------------------------------------------*/
N_EXTERN_LIBRARY ( NWRCODE )
NWAGetNLSFilePath
(
   pnstr8 fileName,
   pnstr8 pathName
);

/*-----------------------------------------------------------------------*/
/* Create a Window pull-down menu in MDI Child Window menu               */
/*                                                                       */
/* This interface uses following menu ids for menu items under Window    */
/* menu. Snapin MDI Child must not use the same ids for any of its menu  */
/* items in its own menu.                                                */
/*-----------------------------------------------------------------------*/

N_EXTERN_LIBRARY ( NWRCODE )
NWACreateWindowMenu
(
   pnstr8  className,
   HMENU   hMenu,
   UINT    menuPos
);

/*-----------------------------------------------------------------------*/
/* Launch Mpew Details window for an object                              */
/*-----------------------------------------------------------------------*/
N_EXTERN_LIBRARY ( NWRCODE )
NWALaunchDetails
(
   pnstr8               classType,
   pnstr8               className,
   pnstr8               objName
);


#ifdef __cplusplus
}
#endif


#endif

