#ifndef __sys_unistd_h__
#define __sys_unistd_h__
/*============================================================================
=  Novell Software Development Kit
=
=  Copyright (C) 1999-2002 Novell, Inc. All Rights Reserved.
=
=  This work is subject to U.S. and international copyright laws and treaties.
=  Use and redistribution of this work is subject  to  the  license  agreement
=  accompanying  the  software  development kit (SDK) that contains this work.
=  However, no part of this work may be revised and/or  modified  without  the
=  prior  written consent of Novell, Inc. Any use or exploitation of this work
=  without authorization could subject the perpetrator to criminal  and  civil
=  liability. 
=
=  Source(s): ISO/IEC (POSIX) 9845:1996; Novell additions
=
=  sys/unistd.h
==============================================================================
*/

/* sysconf() names... */
#define _SC_VERSION                      1
#define _SC_AIO_LISTIO_MAX               2
#define _SC_AIO_MAX                      3
#define _SC_AIO_PRIO_DELTA_MAX           4
#define _SC_ARG_MAX                      5
#define _SC_CHILD_MAX                    6
#define _SC_CLK_TCK                      7
#define _SC_DELAY_TIMER_MAX              8
#define _SC_GETGR_R_SIZE_MAX             9
#define _SC_GETPW_R_SIZE_MAX             10
#define _SC_LOGIN_NAME_MAX               11
#define _SC_MQ_OPEN_MAX                  12
#define _SC_MQ_PRIO_MAX                  13
#define _SC_NGROUPS_MAX                  14
#define _SC_OPEN_MAX                     15
#define _SC_PAGESIZE                     16
#define _SC_RTSIG_MAX                    17
#define _SC_SEM_NSEMS_MAX                18
#define _SC_SEM_VALUE_MAX                19
#define _SC_SIGQUEUE_MAX                 20
#define _SC_STREAM_MAX                   21
#define _SC_THREAD_DESTRUCTOR_ITERATIONS 22
#define _SC_THREAD_KEYS_MAX              23
#define _SC_THREAD_STACK_MIN             24
#define _SC_THREAD_THREADS_MAX           25
#define _SC_TIMER_MAX                    26
#define _SC_TTY_NAME_MAX                 27
#define _SC_TZNAME_MAX                   28
#define _SC_ASYNCHRONOUS_IO              29
#define _SC_FSYNC                        30
#define _SC_JOB_CONTROL                  31
#define _SC_MAPPED_FILES                 32
#define _SC_MEMLOCK                      33
#define _SC_MEMLOCK_RANGE                34
#define _SC_MEMORY_PROTECTION            35
#define _SC_MESSAGE_PASSING              36
#define _SC_PRIORITIZED_IO               37
#define _SC_PRIORITY_SCHEDULING          38
#define _SC_REALTIME_SIGNALS             39
#define _SC_SAVED_IDS                    40
#define _SC_SEMAPHORES                   41
#define _SC_SHARED_MEMORY_OBJECTS        42
#define _SC_SYNCHRONIZED_IO              43
#define _SC_TIMERS                       44
#define _SC_THREADS                      45
#define _SC_THREAD_ATTR_STACKADDR        46
#define _SC_THREAD_ATTR_STACKSIZE        47
#define _SC_THREAD_PRIORITY_SCHEDULING   48
#define _SC_THREAD_PRIO_INHERIT          49
#define _SC_THREAD_PRIO_PROTECT          50
#define _SC_THREAD_PROCESS_SHARED        51
#define _SC_THREAD_SAFE_FUNCTIONS        52

/* pathconf() and fpathconf() names... */
#define _PC_LINK_MAX                     1
#define _PC_MAX_CANON                    2
#define _PC_MAX_INPUT                    3
#define _PC_NAME_MAX                     4
#define _PC_PATH_MAX                     5
#define _PC_PIPE_BUF                     6
#define _PC_NO_TRUNC                     7
#define _PC_VDISABLE                     8
#define _PC_CHOWN_RESTRICTED             9

/* confstr() names... */
#define _CS_PATH                         1
#define _CS_HOSTNAME                     2  /* name of node                */
#define _CS_RELEASE                      3  /* release of operating system */
#define _CS_VERSION                      4  /* version field of utsname    */
#define _CS_MACHINE                      5  /* kind of machine             */
#define _CS_ARCHITECTURE                 6  /* instruction set architecture*/
#define _CS_HW_SERIAL                    7  /* hardware serial number      */
#define _CS_HW_PROVIDER                  8  /* hardware manufacturer       */
#define _CS_SYSNAME                      9  /* name of operating system    */


#endif
